package
{

	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="350")]
	public class anim1 extends Sprite implements ISlider
	{

		//engine variables
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		// camera
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;

		//objects
		private var _Cube:Cube;
		private var _Trident1:Trident;
		private var _Trident2:Trident;
		private var _Container:ObjectContainer3D;

		// Sliders		
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Slider5:Slider;
		private var _Slider6:Slider;

		// Position
		private var InitialXpos:Number=0;
		private var InitialZpos:Number=0;

		public function anim1()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 3000});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .65, y: stage.stageHeight * .6});
			addChild(_View);

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider1=new Slider();
			_Slider1.setMinMax(-800, 800);
			_Slider1.setTitle("cube.x");
			_Slider1.create();
			_Slider1.setCursorPosition(_Container.x);

			_Slider2=new Slider();
			_Slider2.setMinMax(-800, 800);
			_Slider2.setTitle("cube.z");
			_Slider2.create();
			_Slider2.setCursorPosition(_Container.z);

			_Slider3=new Slider();
			_Slider3.setMinMax(0, 600);
			_Slider3.setTitle("cube.moveForward");
			_Slider3.create();
			_Slider3.setCursorPosition(0);

			_Slider4=new Slider();
			_Slider4.setMinMax(0, 600);
			_Slider4.setTitle("cube.moveBackward");
			_Slider4.create();
			_Slider4.setCursorPosition(0);

			_Slider5=new Slider();
			_Slider5.setMinMax(0, 600);
			_Slider5.setTitle("cube.moveLeft");
			_Slider5.create();
			_Slider5.setCursorPosition(0);

			_Slider6=new Slider();
			_Slider6.setMinMax(0, 600);
			_Slider6.setTitle("cube.moveRight");
			_Slider6.create();
			_Slider6.setCursorPosition(0);

		}

		private function createCube():void
		{
			_Cube=new Cube();
			_Cube.width=160;
			_Cube.height=160;
			_Cube.depth=160;

			_Cube.material=new WireColorMaterial(0xF4661B);
		}

		private function updateSlider():void
		{
			_Slider1.setCursorPosition(Math.round(_Container.x));
			_Slider2.setCursorPosition(Math.round(_Container.z));
		}

		private function initObjects():void
		{
			_Container=new ObjectContainer3D;
			_Container.rotationY=50;
			_View.scene.addChild(_Container);

			createCube();

			_Container.addChild(_Cube);

			_Trident2=new Trident();
			_Trident2.scale(0.3);
			_Container.addChild(_Trident2);

			_Trident1=new Trident();
			_Trident1.scale(0.9);
			_View.scene.addChild(_Trident1);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function onMouseWheel(event:MouseEvent):void
		{
			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}
		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{

			if (_Moving)
			{
				_Camera.panAngle=0.5 * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=0.5 * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}

			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					InitialXpos=_Container.x;
					InitialZpos=_Container.z;
					_Container.x=ThisSlider.getCursorPosition();
					InitialXpos=_Container.x;

					break;
				case _Slider2:
					InitialXpos=_Container.x;
					InitialZpos=_Container.z;
					_Container.z=ThisSlider.getCursorPosition();
					InitialZpos=_Container.z;
					break;
				case _Slider3:
					_Container.x=InitialXpos;
					_Container.z=InitialZpos;
					_Container.moveForward(ThisSlider.getCursorPosition());
					updateSlider();
					break;
				case _Slider4:
					_Container.x=InitialXpos;
					_Container.z=InitialZpos;
					_Container.moveBackward(ThisSlider.getCursorPosition());
					updateSlider();
					break;
				case _Slider5:
					_Container.x=InitialXpos;
					_Container.z=InitialZpos;
					_Container.moveLeft(ThisSlider.getCursorPosition());
					updateSlider();
					break;
				case _Slider6:
					_Container.x=InitialXpos;
					_Container.z=InitialZpos;
					_Container.moveRight(ThisSlider.getCursorPosition());
					updateSlider();
					break;
			}
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			_Slider3.setCursorPosition(0);
			_Slider4.setCursorPosition(0);
			_Slider5.setCursorPosition(0);
			_Slider6.setCursorPosition(0);
			InitialXpos=_Container.x;
			InitialZpos=_Container.z;
		}
	}
}