package
{

	import away3d.containers.Scene3D;
	import away3d.containers.View3D;
	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.containers.ObjectContainer3D;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="320")]
	public class anim2 extends Sprite implements ISlider
	{

		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;

		private var _Cube:Cube;
		private var _Trident1:Trident;
		private var _Trident2:Trident;
		private var _Container:ObjectContainer3D;
		private var _Sphere:Sphere;

		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Slider5:Slider;
		private var _Slider6:Slider;

		private var InitialXrot:Number=0;
		private var InitialYrot:Number=0;
		private var InitialZrot:Number=0;

		public function anim2()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 4000});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .65, y: stage.stageHeight * .6});
			addChild(_View);

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider1=new Slider();
			_Slider1.setMinMax(0, 360);
			_Slider1.setTitle("cube.rotationX");
			_Slider1.create();
			_Slider1.setCursorPosition(_Container.rotationX);

			_Slider2=new Slider();
			_Slider2.setMinMax(0, 360);
			_Slider2.setTitle("cube.rotationY");
			_Slider2.create();
			_Slider2.setCursorPosition(_Container.rotationY);

			_Slider3=new Slider();
			_Slider3.setMinMax(0, 360);
			_Slider3.setTitle("cube.rotationZ");
			_Slider3.create();
			_Slider3.setCursorPosition(_Container.rotationY);

			_Slider4=new Slider();
			_Slider4.setMinMax(0, 360);
			_Slider4.setTitle("cube.roll");
			_Slider4.create();
			_Slider4.setCursorPosition(0);

			_Slider5=new Slider();
			_Slider5.setMinMax(0, 360);
			_Slider5.setTitle("cube.pitch");
			_Slider5.create();
			_Slider5.setCursorPosition(0);

			_Slider6=new Slider();
			_Slider6.setMinMax(0, 360);
			_Slider6.setTitle("cube.yaw");
			_Slider6.create();
			_Slider6.setCursorPosition(0);
		}

		private function createCube():void
		{
			_Cube=new Cube();
			_Cube.width=360;
			_Cube.height=360;
			_Cube.depth=360;
			_Cube.material=new WireColorMaterial(0xF4661B);
		}

		private function updateSlider():void
		{
			_Slider1.setCursorPosition(Math.round(_Container.x));
			_Slider2.setCursorPosition(Math.round(_Container.z));
		}

		private function initObjects():void
		{
			_Container=new ObjectContainer3D;
			_View.scene.addChild(_Container);

			createCube();

			_Container.addChild(_Cube);

			_Trident2=new Trident();
			_Trident2.scale(0.3);
			_Container.addChild(_Trident2);

			_Trident1=new Trident();
			_Trident1.scale(0.9);
			_View.scene.addChild(_Trident1);

			_Sphere=new Sphere();
			_Sphere.radius=80;
			_Sphere.x=500;
			_Sphere.z=-500;
			_Sphere.y=800;
			_Sphere.material=new ColorMaterial(0x884477);
			_View.scene.addChild(_Sphere);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
			_Sphere.addEventListener(MouseEvent3D.MOUSE_DOWN, onSphereClick);
		}

		private function onMouseWheel(event:MouseEvent):void
		{
			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}
		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;
		}

		private function onSphereClick(event:MouseEvent3D):void
		{
			_Container.lookAt(new Vector3D(500, 800, -500));
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{
			if (_Moving)
			{
				_Camera.panAngle=0.5 * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=0.5 * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}

			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					InitialXrot=_Container.rotationX;
					InitialYrot=_Container.rotationY;
					InitialZrot=_Container.rotationZ;
					_Container.rotationX=ThisSlider.getCursorPosition();
					InitialXrot=_Container.rotationX;

					break;
				case _Slider2:
					InitialXrot=_Container.rotationX;
					InitialYrot=_Container.rotationY;
					InitialZrot=_Container.rotationZ;
					_Container.rotationY=ThisSlider.getCursorPosition();
					InitialYrot=_Container.rotationY;
					break;
				case _Slider3:
					InitialXrot=_Container.rotationX;
					InitialYrot=_Container.rotationY;
					InitialZrot=_Container.rotationZ;
					_Container.rotationY=ThisSlider.getCursorPosition();
					InitialZrot=_Container.rotationZ;
					break;
				case _Slider4:
					_Container.rotationX=InitialXrot;
					_Container.rotationY=InitialYrot;
					_Container.rotationZ=InitialZrot;
					_Container.roll(ThisSlider.getCursorPosition());
					updateSlider();
					break;
				case _Slider5:
					_Container.rotationX=InitialXrot;
					_Container.rotationY=InitialYrot;
					_Container.rotationZ=InitialZrot;
					_Container.pitch(ThisSlider.getCursorPosition());
					updateSlider();
					break;
				case _Slider6:
					_Container.rotationX=InitialXrot;
					_Container.rotationY=InitialYrot;
					_Container.rotationZ=InitialZrot;
					_Container.yaw(ThisSlider.getCursorPosition());
					updateSlider();
					break;
			}
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			_Slider4.setCursorPosition(0);
			_Slider5.setCursorPosition(0);
			_Slider6.setCursorPosition(0);
			InitialXrot=_Container.rotationX;
			InitialYrot=_Container.rotationY;
			InitialZrot=_Container.rotationZ;
		}
	}
}