package
{

	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.render.Renderer;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="350")]
	public class anim3 extends Sprite implements ISlider
	{

		//engine variables
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		// camera
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;

		//objects
		private var _TridentContainer:Trident;
		private var _TridentCube:Trident;
		private var _TridentSphere:Trident;
		private var _TridentCylinder:Trident;
		private var _Container:ObjectContainer3D;
		private var _Sphere:Sphere;
		private var _Cube:Cube;
		private var _Plane:Plane;
		private var _Cylinder:Cylinder;
		private var _Slider1:Slider;

		public function anim3()
		{
			initEngine();
			initObjects();
			initListeners();
			initSliders();
		}

		private function initSliders():void
		{
			_Slider1=new Slider(stage, this);
			_Slider1.setCursorSize(8, 10);
			_Slider1.setFont(12);
			_Slider1.setWidth(80);
			_Slider1.setMinMax(0, 2, 1);
			_Slider1.setTitle("scale");
			_Slider1.setPosition(20, 40);
			_Slider1.create();
			_Slider1.setCursorPosition(1);
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 2000});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * 0.5, y: stage.stageHeight * .6});
			addChild(_View);

			_View.renderer=Renderer.CORRECT_Z_ORDER;

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);

		}

		private function initObjects():void
		{
			_Container=new ObjectContainer3D;

			_View.scene.addChild(_Container);

			_Plane=new Plane();
			_Plane.width=1000;
			_Plane.height=1000;
			_Plane.segmentsH=1;
			_Plane.segmentsW=1;
			_Plane.x=-5;
			_Plane.y=10;
			_Plane.bothsides=true;
			_Plane.material=new WireColorMaterial(0xF4661B);

			_Container.addChild(_Plane);

			_TridentContainer=new Trident();
			_TridentContainer.scale(0.5);
			_TridentContainer.y=50;
			_Container.addChild(_TridentContainer);

			_TridentSphere=new Trident();
			_TridentSphere.scale(0.3);
			_TridentSphere.x=200;
			_TridentSphere.z=300;
			_TridentSphere.y=150;
			_TridentSphere.rotationY=50;
			_TridentSphere.rotationX=40;
			_Container.addChild(_TridentSphere);

			_Cylinder=new Cylinder();
			_Cylinder.radius=100;
			_Cylinder.height=300;
			_Cylinder.rotationX=90;
			_Cylinder.rotationY=40;
			_Cylinder.segmentsH=5;
			_Cylinder.segmentsW=5;
			_Cylinder.x=-300;
			_Cylinder.y=10;
			_Cylinder.y=100;
			_Cylinder.material=new WireColorMaterial(0xee0000);
			_Container.addChild(_Cylinder);

			_TridentCylinder=new Trident();
			_TridentCylinder.scale(0.3);
			_TridentCylinder.x=-300;
			_TridentCylinder.z=10;
			_TridentCylinder.y=100;
			_TridentCylinder.rotationX=90;
			_TridentCylinder.rotationY=40;
			_Container.addChild(_TridentCylinder);

			_Sphere=new Sphere();
			_Sphere.radius=140;
			_Sphere.x=200;
			_Sphere.z=300;
			_Sphere.rotationY=50;
			_Sphere.rotationX=40;
			_Sphere.y=150;
			_Sphere.material=new WireColorMaterial(0x008888);
			_Container.addChild(_Sphere);

			_Cube=new Cube();
			_Cube.width=140;
			_Cube.height=200;
			_Cube.depth=200;
			_Cube.segmentsH=1;
			_Cube.segmentsW=1;
			_Cube.x=200;
			_Cube.y=120;
			_Cube.z=-300;
			_Cube.rotationY=120;
			_Cube.material=new WireColorMaterial(0x0bb00);
			_Container.addChild(_Cube);

			_TridentCube=new Trident();
			_TridentCube.scale(0.3);
			_TridentCube.x=200;
			_TridentCube.z=-300;
			_TridentCube.y=120;
			_TridentCube.rotationY=120;
			_Container.addChild(_TridentCube);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);

		}

		private function onMouseWheel(event:MouseEvent):void
		{
			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}
		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{
			if (_Moving)
			{
				_Camera.panAngle=0.5 * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=0.5 * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}

			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			_Container.scale(ThisSlider.getCursorPosition());
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
		}
	}
}