package
{

	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import com.greensock.TweenLite;

	import flash.display.*;
	import flash.events.*;
	import flash.text.TextField;
	import flash.text.TextFormat;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="590", height="350")]
	public class anim4 extends Sprite implements ISlider, IButton
	{

		//engine variables
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		// camera
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;

		//objects
		private var _Cube:Cube;
		private var _Trident1:Trident;
		private var _Trident2:Trident;
		private var _Container:ObjectContainer3D;

		// Sliders and controls	
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Slider5:Slider;
		private var _Slider6:Slider;
		private var _Button:Button;

		// Position
		private var _Xpos:Number=0;
		private var _Ypos:Number=0;
		private var _Zpos:Number=0;
		private var _XRot:Number=0;
		private var _YRot:Number=0;
		private var _ZRot:Number=0;

		// text field
		private var _TextArea:TextField;
		private var _TextFormat:TextFormat;

		public function anim4()
		{
			initEngine();
			initObjects();
			initText();
			initControls();
			initListeners();
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 2200});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .6, y: stage.stageHeight * .5});
			addChild(_View);

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);
		}

		private function initText():void
		{
			_TextFormat=new TextFormat();
			_TextFormat.font="Verdana";
			_TextFormat.color=0x333333;

			_TextFormat.size=12;

			_TextArea=new TextField();
			_TextArea.borderColor=0x334400;
			_TextArea.height=12;
			_TextArea.selectable=false;
			_TextArea.defaultTextFormat=_TextFormat;
			_TextArea.text=generateText();

			stage.addChild(_TextArea);

			_TextArea.autoSize="left";
			_TextArea.x=20;
			_TextArea.y=300;

		}

		private function generateText():String
		{
			return "TweenLite.to(_Container, 1, {x:" + _Xpos + ",y:" + _Ypos + ",z:" + _Zpos + ",rotationX:" + _XRot + ",rotationY:" + _YRot + ",rotationZ:" + _ZRot + "})";
		}

		private function initControls():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider1=new Slider();
			_Slider1.setMinMax(-300, 300);
			_Slider1.setTitle("cube.x");
			_Slider1.create();
			_Slider1.setCursorPosition(_Xpos);

			_Slider2=new Slider();
			_Slider2.setMinMax(-300, 300);
			_Slider2.setTitle("cube.y");
			_Slider2.create();
			_Slider2.setCursorPosition(_Ypos);

			_Slider3=new Slider();
			_Slider3.setMinMax(-300, 300);
			_Slider3.setTitle("cube.z");
			_Slider3.create();
			_Slider3.setCursorPosition(_Zpos);

			_Slider4=new Slider();
			_Slider4.setMinMax(0, 360);
			_Slider4.setTitle("rotx");
			_Slider4.create();
			_Slider4.setCursorPosition(_XRot);

			_Slider5=new Slider();
			_Slider5.setMinMax(0, 360);
			_Slider5.setTitle("roty");
			_Slider5.create();
			_Slider5.setCursorPosition(_YRot);

			_Slider6=new Slider();
			_Slider6.setMinMax(0, 360);
			_Slider6.setTitle("rotz");
			_Slider6.create();
			_Slider6.setCursorPosition(_ZRot);

			_Button=new Button(this, this);
			_Button.setDimenstion(100, 20);
			_Button.setPosition(20, 260);
			_Button.setText("Tween");
			_Button.create();

		}

		private function createCube():void
		{
			_Cube=new Cube();
			_Cube.width=160;
			_Cube.height=160;
			_Cube.depth=160;
			_Cube.material=new WireColorMaterial(0xF4661B);

		}

		private function initObjects():void
		{
			_Container=new ObjectContainer3D;
			_View.scene.addChild(_Container);

			createCube();

			_Container.addChild(_Cube);

			_Trident2=new Trident();
			_Trident2.scale(0.3);
			_Container.addChild(_Trident2);

			_Trident1=new Trident();
			_Trident1.scale(0.6);
			_View.scene.addChild(_Trident1);

		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function onMouseWheel(event:MouseEvent):void
		{

			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}

		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;

		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{
			if (_Moving)
			{
				_Camera.panAngle=0.5 * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=0.5 * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}

			_Camera.hover();
			_View.render();
		}

		// override ISlider's properties
		public function onSliderMove(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{

				case _Slider1:
					_Xpos=ThisSlider.getCursorPosition();
					_TextArea.text=generateText();
					break;
				case _Slider2:
					_Ypos=ThisSlider.getCursorPosition();
					_TextArea.text=generateText();
					break;
				case _Slider3:
					_Zpos=ThisSlider.getCursorPosition();
					_TextArea.text=generateText();
					break;
				case _Slider4:
					_XRot=ThisSlider.getCursorPosition();
					_TextArea.text=generateText();
					break;
				case _Slider5:
					_YRot=ThisSlider.getCursorPosition();
					_TextArea.text=generateText();
					break;
				case _Slider6:
					_ZRot=ThisSlider.getCursorPosition();
					_TextArea.text=generateText();
					break;
			}
		}

		// override ISlider's properties
		public function onSliderRelease(ThisSlider:Slider):void
		{

		}

		public function onButtonClick(ThisBuuton:Button):void
		{
			TweenLite.to(_Container, 1, {x: _Xpos, y: _Ypos, z: _Zpos, rotationX: _XRot, rotationY: _YRot, rotationZ: _ZRot});
		}

	}
}