package
{

	import away3d.extrusions.PathExtrusion;
	import SGComponents.*;

	import away3d.animators.*;
	import away3d.animators.data.*;
	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.geom.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.extrusions.PathExtrusion;
	import away3d.lights.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="380")]
	public class anim5 extends Sprite implements ISlider, ICheckBox
	{

		//engine variables
		private var _Camera:Camera3D;
		private var _View:View3D;

		//objects
		private var _CrossSection:Array=[];
		private var _PathExtrusion:PathExtrusion;
		private var _Path:Path;
		private var _Sphere:Sphere;
		private var _Pathanimator:PathAnimator;
		private var _Cube:Cube;
		private var _Time:Number=0;

		// Controls		
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Checkbox1:CheckBox;
		private var _Checkbox2:CheckBox;

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.STICKY=true;
			Slider.CONTROL_WIDTH=20;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;

			_Slider1=new Slider();
			_Slider1.setMinMax(0, 1);
			_Slider1.setTitle("targetObject");
			_Slider1.create();
			_Slider1.setCursorPosition(0);

			Slider.CONTROL_WIDTH=80;

			_Slider2=new Slider();
			_Slider2.setMinMax(-400, 400);
			_Slider2.setTitle("offset x");
			_Slider2.create();
			_Slider2.setCursorPosition(-200);

			_Slider3=new Slider();
			_Slider3.setMinMax(-400, 400);
			_Slider3.setTitle("offset y");
			_Slider3.create();
			_Slider3.setCursorPosition(390);

			_Slider4=new Slider();
			_Slider4.setMinMax(-400, 400);
			_Slider4.setTitle("offset z");
			_Slider4.create();
			_Slider4.setCursorPosition(0);

			CheckBox.X_POS=530;
			CheckBox.Y_POS=20;
			CheckBox.Y_OFFSET=20;
			CheckBox.CALLBACK_INTERFACE=this;
			CheckBox.FONT_SIZE=12;

			_Checkbox1=new CheckBox(this, true);
			_Checkbox1.setTitle("cube");
			_Checkbox1.setOrientation(CheckBox.RIGHT);
			_Checkbox1.create();
			_Checkbox1.setState(true);

			_Checkbox2=new CheckBox(this, true);
			_Checkbox2.setTitle("camera");
			_Checkbox2.setOrientation(CheckBox.RIGHT);
			_Checkbox2.create();
			_Checkbox2.setState(false);

		}

		public function anim5()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);

		}

		private function initEngine():void
		{
			_Camera=new Camera3D({zoom: 6, focus: 100, distance: 5000});
			_Camera.y=1000;
			_Camera.x=-1000;
			_Camera.z=-6000;
			_View=new View3D({camera: _Camera, x: stage.stageWidth * .5, y: stage.stageHeight * .4});
			addChild(_View);
			_Camera.lookAt(new Vector3D(0, 0, 0));
		}

		private function initObjects():void
		{

			_Path=new Path([new Vector3D(-1500, 0, -2000), new Vector3D(-1500, 0, 1000), new Vector3D(-1000, 0, 1000), new Vector3D(-1000, 0, 1000), new Vector3D(3000, 0, 1000), new Vector3D(1600, 0000, -2000), new Vector3D(1600, 0000, -2000), new Vector3D(-1000, -500, -5000), new Vector3D(-1500, 0, -2000),]);

			_CrossSection.push(new Vector3D(-50, -50, 0));
			_CrossSection.push(new Vector3D(-50, 50, 0));
			_CrossSection.push(new Vector3D(50, 50, 0));
			_CrossSection.push(new Vector3D(50, -50, 0));
			_CrossSection.push(new Vector3D(-50, -50, 0));

			var mat:WireColorMaterial=new WireColorMaterial(0x889900);
			_PathExtrusion=new PathExtrusion(_Path, _CrossSection, null, null, {aligntopath: true, scaling: 1, closepath: false, recenter: true, subdivision: 40, material: mat, bothsides: true});

			_View.scene.addChild(_PathExtrusion);
			_PathExtrusion.x=60;
			_PathExtrusion.y=30;

			_Cube=new Cube();
			_Cube.width=360;
			_Cube.height=360;
			_Cube.depth=360;

			_Cube.material=new WireColorMaterial(0xF4661B);
			_View.scene.addChild(_Cube);

			_Sphere=new Sphere();
			_Sphere.radius=80;
			_Sphere.x=0;
			_Sphere.z=-2500;
			_Sphere.y=0;
			_Sphere.material=new ColorMaterial(0x2255dd);
			_View.scene.addChild(_Sphere);

			var init:Object={length: 100000, lookat: false, alignToPath: false, targetobject: null, offset: new Vector3D(-200, 390, 0), rotations: null, fps: 30, easein: false, easeout: false};
			_Pathanimator=new PathAnimator(_Path, _Cube, init);
			_Pathanimator.length=1;
		}

		private function onEnterFrame(event:Event):void
		{
			_Time=(_Time + 0.001 > 1) ? 0 : _Time + 0.005;
			_Pathanimator.update(_Time);

			_View.render();
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:

					if (ThisSlider.getCursorPosition() == 1)
					{
						_Pathanimator.targetObject=_Sphere;
					}
					else
					{
						_Pathanimator.targetObject=null;
					}
					break;

				case _Slider2:
					_Pathanimator.offset.x=ThisSlider.getCursorPosition();
					break;

				case _Slider3:
					_Pathanimator.offset.y=ThisSlider.getCursorPosition();
					break;

				case _Slider4:
					_Pathanimator.offset.z=ThisSlider.getCursorPosition();
					break;
			}
		}

		public function onCheckBoxStateChange(ThisCheckBox:CheckBox):void
		{

			switch (ThisCheckBox)
			{
				case _Checkbox1:
					_Pathanimator.target=_Cube;
					_Camera.y=1000;
					_Camera.x=-1000;
					_Camera.z=-6000;
					_Camera.lookAt(new Vector3D(0, 0, 0));
					_View.scene.addChild(_Cube);
					break;

				case _Checkbox2:
					_Pathanimator.target=_Camera;
					_View.scene.removeChild(_Cube);

					break;
			}
		}
	}
}