package
{

	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.cameras.lenses.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.filter.FogFilter;
	import away3d.core.math.*;
	import away3d.core.render.BasicRenderer;
	import away3d.core.render.Renderer;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	
	import objects.CameraObject;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="220")]
	public class anim2 extends Sprite implements ISlider
	{

		private var _Origin:Vector3D;

		private var _Container:ObjectContainer3D;

		private var _Camera1:HoverCamera3D;
		private var _View1:SingleView;

		private var _Camera2:HoverCamera3D;
		private var _View2:SingleView;

		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;

		private var _CameraObject:CameraObject;
		private var _PlaneArray:Array;

		private var _Min:Number=500;
		private var _Max:Number=4000;
		private var _Subdivision:Number=5;

		private var _Fog:FogFilter;

		public function anim2()
		{
			_Origin=new Vector3D(0, 0, 0);
			_PlaneArray=new Array();

			initEngine1();
			initEngine2();

			initObjects1();
			initObjects2();

			createFog();

			initSliders1();

			generatePlane(_Subdivision, _Camera1.z - _Min, _Camera1.z - _Max);

			_View1.View.render();
			_View2.View.render();

			addEventListener(Event.ENTER_FRAME, onEnterFrame);

		}

		public function createFog():void
		{
			var fogMaterial:ColorMaterial=new ColorMaterial(0x555555);

			_Fog=new FogFilter({minZ: _Min, maxZ: _Max, subdivisions: _Subdivision, material: fogMaterial});

			_View1.View.renderer=new BasicRenderer(_Fog);
		}

		private function onEnterFrame(event:Event):void
		{
			_Container.yaw(1);

			_View2.View.render();
		}

		private function initEngine1():void
		{
			_Camera1=new HoverCamera3D({zoom: 2, focus: 100, distance: 1000});
			_View1=new SingleView(stage.stageWidth / 3, stage.stageHeight, 2 * stage.stageWidth / 3-1, 0, _Camera1);

			_Camera1.z=1500;
			_Camera1.y=0;
			_Camera1.lookAt(_Origin);

			addChild(_View1);
		}

		private function initEngine2():void
		{
			_Camera2=new HoverCamera3D({zoom: 1, focus: 300, distance: 3000});

			_View2=new SingleView(2 * stage.stageWidth / 3, stage.stageHeight, 0, 0, _Camera2);
			_Camera2.z=4500;
			_Camera2.x=-3000;
			_Camera2.y=1000;
			_Camera2.lookAt(_Origin);
			_View2.View.renderer=Renderer.CORRECT_Z_ORDER;

			addChild(_View2);
		}

		private function initObjects1():void
		{
			var sphere1:Sphere=new Sphere();
			sphere1.radius=200;
			sphere1.x=0;
			sphere1.y=0;
			sphere1.z=100;
			sphere1.material=new WireColorMaterial(0x0000ff);
			_View1.View.scene.addChild(sphere1);

			var sphere2:Sphere=new Sphere();
			sphere2.radius=400;
			sphere2.x=-700;
			sphere2.y=0;
			sphere2.z=-800;
			sphere2.material=new WireColorMaterial(0x00ff00);
			_View1.View.scene.addChild(sphere2);

			var sphere3:Sphere=new Sphere();
			sphere3.radius=400;
			sphere3.x=800;
			sphere3.y=0;
			sphere3.z=-1500;
			sphere3.material=new WireColorMaterial(0xff0000);
			_View1.View.scene.addChild(sphere3)

		}

		private function generatePlane(subDivision:int, min:int, max:int):void
		{
			while (_PlaneArray.length != 0)
			{

				var planebuffer:Plane=_PlaneArray.pop();
				_Container.removeChild(planebuffer);
			}

			var positionOffset:int=(max - min) / subDivision;

			for (var i:int=1; i <= subDivision; i++)
			{
				var plane:Plane=new Plane({width: 200, height: 200, bothsides: true, z: -100, ownCanvas: true});
				plane.material=new ColorMaterial(0x555555);
				plane.rotationX=90;
				plane.rotationY=180;
				plane.scale(15);
				plane.alpha=0.5;
				plane.z=positionOffset * i + min;
				_Container.addChild(plane);

				_PlaneArray.push(plane);
			}
		}

		private function initObjects2():void
		{
			_Container=new ObjectContainer3D();

			var sphere1:Sphere=new Sphere();
			sphere1.radius=200;
			sphere1.x=0;
			sphere1.y=0;
			sphere1.z=100;
			sphere1.material=new WireColorMaterial(0x0000ff);
			_Container.addChild(sphere1);

			var sphere2:Sphere=new Sphere();
			sphere2.radius=400;
			sphere2.x=-700;
			sphere2.y=0;
			sphere2.z=-800;
			sphere2.material=new WireColorMaterial(0x00ff00);
			sphere2.alpha=50;
			_Container.addChild(sphere2);

			var sphere3:Sphere=new Sphere();
			sphere3.radius=400;
			sphere3.x=800;
			sphere3.y=0;
			sphere3.z=-1500;
			sphere3.material=new WireColorMaterial(0xff0000);
			_Container.addChild(sphere3)

			_CameraObject=new CameraObject();
			_CameraObject.bothsides=true;
			_CameraObject.material=new WireColorMaterial(0xcc8800);
			_Container.addChild(_CameraObject);

			_CameraObject.scale(12);
			_CameraObject.scaleX=15;

			_CameraObject.x=_Camera1.x;
			_CameraObject.y=_Camera1.y;
			_CameraObject.z=_Camera1.z;

			_CameraObject.lookAt(_Origin);

			_CameraObject.yaw(90);

			_View2.View.scene.addChild(_Container);
			_Container.x=-500;
			_Container.y=300;
			_Container.scale(0.8);
		}

		private function initSliders1():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;
			Slider.CURSOR_COLOR=0x222222;
			Slider.LINE_COLOR=0x444444;
			Slider.TEXT_COLOR=0x444444;

			_Slider1=new Slider();
			_Slider1.setMinMax(0, 3000);
			_Slider1.setTitle("min");
			_Slider1.create();
			_Slider1.setCursorPosition(_Min);

			_Slider2=new Slider();
			_Slider2.setMinMax(0, 5000);
			_Slider2.setTitle("max");
			_Slider2.create();
			_Slider2.setCursorPosition(_Max);

			_Slider3=new Slider();
			_Slider3.setMinMax(0, 10);
			_Slider3.setTitle("Subdivision");
			_Slider3.create();
			_Slider3.setCursorPosition(_Subdivision);

		}

		public function onSliderMove(ThisSlider:Slider):void
		{
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_Min=ThisSlider.getCursorPosition();
					createFog();
					generatePlane(_Subdivision, _Camera1.z - _Min, _Camera1.z - _Max);
					_View1.View.render();

					break;
				case _Slider2:
					_Max=ThisSlider.getCursorPosition();
					createFog();
					generatePlane(_Subdivision, _Camera1.z - _Min, _Camera1.z - _Max);
					_View1.View.render();

					break;
				case _Slider3:
					_Subdivision=ThisSlider.getCursorPosition();
					createFog();
					generatePlane(_Subdivision, _Camera1.z - _Min, _Camera1.z - _Max);
					_View1.View.render();
					break;
			}
		}
	}
}