package
{

	import SGComponents.*;

	import away3d.animators.*;
	import away3d.animators.data.*;
	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.lights.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	import away3d.core.render.Renderer;
	import away3d.core.utils.DofCache;
	import away3d.sprites.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	import objects.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="280")]
	public class anim3 extends Sprite implements ISlider
	{

		//red marble
		[Embed(source="assets/red.png")]
		public var Red:Class;

		[Embed(source="assets/green.png")]
		public var Green:Class;

		//engine variables
		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;
		private var _DofSprite2D_1:Mesh;
		private var _DofSprite2D_2:Mesh;
		private var _DofSprite2D_3:Mesh;
		private var _Container:ObjectContainer3D;
		private var _Trident:Trident;
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Aperture:Number=100;
		private var _Maxblur:Number=50;
		private var _Focus:Number = 1000;
		private var _Material1:BitmapMaterial;
		private var _Material2:BitmapMaterial;
		private var _Material3:BitmapMaterial;

		public function anim3()
		{
			initEngine();
			initMaterials();
			initObjects(true);
			initListeners();
			initSliders();
		}
		
		private function initMaterials():void
		{
			_Material1 = new BitmapMaterial(Cast.bitmap(Red));
    		_Material2 = new BitmapMaterial(Cast.bitmap(Green));
    		_Material3 = new BitmapMaterial(Cast.bitmap(Green));
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 900});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .6, y: stage.stageHeight * .65});
			_View.forceUpdate = true;
			
			addChild(_View);

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider1=new Slider();
			_Slider1.setMinMax(0, 200);
			_Slider1.setTitle("aperture");
			_Slider1.create();
			_Slider1.setCursorPosition(100);

			_Slider2=new Slider();
			_Slider2.setMinMax(500, 1500);
			_Slider2.setTitle("focus");
			_Slider2.create();
			_Slider2.setCursorPosition(1000);
			
		}

		private function initObjects(usedof:Boolean):void
		{

			_Trident=new Trident();
			_Trident.scale(0.2);
			_View.scene.addChild(_Trident);

			DofCache.aperture=_Aperture;
			DofCache.usedof=usedof;
			DofCache.maxblur=_Maxblur;
			DofCache.focus = _Focus;
			
			_DofSprite2D_1 = new Mesh();
			_DofSprite2D_1.addSprite(new DepthOfFieldSprite(_Material1));
			_DofSprite2D_1.x=100;
			_DofSprite2D_1.y=100;

			_DofSprite2D_2 = new Mesh();
			_DofSprite2D_2.addSprite(new DepthOfFieldSprite(_Material2));
			_DofSprite2D_2.x=300;
			_DofSprite2D_2.y=150;
			_DofSprite2D_2.z=100;

			_DofSprite2D_3 = new Mesh();
			_DofSprite2D_3.addSprite(new DepthOfFieldSprite(_Material3));
			_DofSprite2D_3.x=-200;
			_DofSprite2D_3.y=150;
			_DofSprite2D_3.z=100;

			_DofSprite2D_1.ownCanvas=true;
			_DofSprite2D_1.blendMode=BlendMode.DARKEN;

			_DofSprite2D_2.ownCanvas=true;
			_DofSprite2D_2.blendMode=BlendMode.DARKEN;

			_DofSprite2D_3.ownCanvas=true;
			_DofSprite2D_3.blendMode=BlendMode.DARKEN;

			_Container=new ObjectContainer3D(_DofSprite2D_1, _DofSprite2D_2, _DofSprite2D_3);
			_DofSprite2D_1.scale(10);

			_View.scene.addChild(_Container);
			
		}

		private function onMouseWheel(event:MouseEvent):void
		{
			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}
		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{
			var cameraSpeed:Number=0.5;

			if (_Moving)
			{
				_Camera.panAngle=cameraSpeed * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=cameraSpeed * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}

			_Camera.hover();
			_View.render();

		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_Aperture=ThisSlider.getCursorPosition();
					DofCache.aperture=_Aperture;
					break;
				case _Slider2:
					_Focus=ThisSlider.getCursorPosition();
					DofCache.focus=_Focus;
					break;
			}
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
		}

	}
}