package
{
	import SGComponents.*;
	
	import away3d.containers.LODObject;
	import away3d.containers.Scene3D;
	import SGComponents.*;

	import away3d.animators.*;
	import away3d.animators.data.*;
	import away3d.cameras.*;
	import away3d.containers.View3D;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.lights.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	import away3d.core.render.Renderer;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	import objects.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="400", height="300")]
	public class anim4 extends Sprite implements ISlider
	{
		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;
		private var _Carafe_HighPoly:Carafe_highpoly;
		private var _Carafe_LowPoly:Carafe_lowpoly;
		private var _Carafe_MediumPoly:Carafe_mediumpoly;
		
		private var _Slider1:Slider;
		
		public function anim4()
		{
			initEngine();
			initObjects();
			initListeners();
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 500});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .5, y: stage.stageHeight * .5});
			_View.renderer=Renderer.INTERSECTING_OBJECTS;
			addChild(_View);

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);
			
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;
			Slider.CURSOR_COLOR=0x222222;
			Slider.LINE_COLOR=0x444444;
			Slider.TEXT_COLOR=0x444444;

			_Slider1=new Slider();
			_Slider1.setMinMax(50, 1000);
			_Slider1.setTitle("Distance caméra");
			_Slider1.create();
			_Slider1.setCursorPosition(500);
		}

		private function initObjects():void
		{			
			_Carafe_HighPoly=new Carafe_highpoly();
			_Carafe_HighPoly.rotationX = 90;
			_Carafe_HighPoly.z = 0;
			_Carafe_HighPoly.scale(1.7);
			_Carafe_HighPoly.material=new WireColorMaterial(0xF4661B);
			var lod0:LODObject=new LODObject(_Carafe_HighPoly);
			lod0.minp=2;
			lod0.maxp=100;
			_View.scene.addChild(lod0);

			_Carafe_MediumPoly=new Carafe_mediumpoly();
			_Carafe_MediumPoly.rotationX = 90;
			_Carafe_MediumPoly.z = 0;
			_Carafe_MediumPoly.scale(1.7);
			_Carafe_MediumPoly.material=new WireColorMaterial(0xF4661B);
			var lod1:LODObject=new LODObject(_Carafe_MediumPoly);
			lod1.minp=1;
			lod1.maxp=2;
			_View.scene.addChild(lod1);

			_Carafe_LowPoly=new Carafe_lowpoly();
			_Carafe_LowPoly.rotationX=90;
			_Carafe_LowPoly.z = 0;
			_Carafe_LowPoly.scale(1.7);
			_Carafe_LowPoly.material=new WireColorMaterial(0xF4661B);
			var lod2:LODObject=new LODObject(_Carafe_LowPoly);
			lod2.minp=0;
			lod2.maxp=1;
			_View.scene.addChild(lod2);
		}

		private function onMouseWheel(event:MouseEvent):void
		{
			_Camera.distance+=-event.delta * 20;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}
		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{
			var cameraSpeed:Number=0.5;

			if (_Moving)
			{
				_Camera.panAngle=cameraSpeed * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=cameraSpeed * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}

			_Camera.hover();
			_View.render();
		}
		
		public function onSliderMove(ThisSlider:Slider):void
		{
			_Camera.distance = ThisSlider.getCursorPosition();
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
		}
	}
}