package
{

	import SGComponents.*;

	import away3d.animators.*;
	import away3d.animators.data.*;
	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.render.Renderer;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.lights.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="280")]
	public class anim6 extends Sprite implements ICheckBox
	{

		//engine variables
		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;
		private var _Checkbox1:CheckBox;

		private var _Plane:Plane;
		private var _Cube:Cube;

		public function anim6()
		{
			initEngine();
			initObjects();
			initControls();
			initListeners();
		}

		public function initControls():void
		{
			CheckBox.X_POS=20;
			CheckBox.Y_POS=20;
			CheckBox.Y_OFFSET=20;
			CheckBox.ORIENTATION=CheckBox.LEFT;
			CheckBox.CALLBACK_INTERFACE=this;
			CheckBox.FONT_SIZE=12;

			_Checkbox1=new CheckBox(this, false);
			_Checkbox1.setTitle("Plane PushBack");
			_Checkbox1.create();
			_Checkbox1.setState(false);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 900});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .5, y: stage.stageHeight * .5});
			addChild(_View);

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=0;
			_Camera.hover(true);
		}

		private function initObjects():void
		{
			_Plane=new Plane();
			_Plane.height=200;
			_Plane.bothsides=true;
			_Plane.material=new WireColorMaterial(0xaa0000);
			_Plane.scale(3);
			_View.scene.addChild(_Plane);

			_Cube=new Cube();
			_Cube.y=51;
			_Cube.material=new WireColorMaterial(0x00aa00);
			_Cube.scale(1);
			_View.scene.addChild(_Cube);
		}

		private function onMouseWheel(event:MouseEvent):void
		{
			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}
		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{
			var cameraSpeed:Number=0.5;

			if (_Moving)
			{
				_Camera.panAngle=cameraSpeed * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=cameraSpeed * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}
			_Camera.hover();
			_View.render();
		}

		public function onCheckBoxStateChange(ThisCheckBox:CheckBox):void
		{
			switch (ThisCheckBox)
			{
				case _Checkbox1:

					_Plane.pushback=ThisCheckBox.getState();

					break;
			}
		}

	}
}