package
{

	import SGComponents.*;

	import away3d.animators.*;
	import away3d.animators.data.*;
	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.clip.*;
	import away3d.core.math.*;
	import away3d.core.render.Renderer;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.lights.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="280")]
	public class anim9 extends Sprite implements ICheckBox, ISlider
	{
		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		private var _Checkbox1:CheckBox;
		private var _Checkbox2:CheckBox;

		private var _NearfieldClipping:NearfieldClipping;
		private var _RectangleClipping:RectangleClipping;
		
		private var _Slider1:Slider;

		public function anim9()
		{
			initEngine();
			initObjects();
			initControls();
			initListeners();
		}

		public function initControls():void
		{
			CheckBox.X_POS=20;
			CheckBox.Y_POS=60;
			CheckBox.Y_OFFSET=20;
			CheckBox.ORIENTATION=CheckBox.LEFT;
			CheckBox.CALLBACK_INTERFACE=this;
			CheckBox.FONT_SIZE=12;

			_Checkbox1=new CheckBox(this, true);
			_Checkbox1.setTitle("RectangleClipping");
			_Checkbox1.create();
			_Checkbox1.setState(true);

			_Checkbox2=new CheckBox(this, true);
			_Checkbox2.setTitle("NearfieldClipping");
			_Checkbox2.create();
			_Checkbox2.setState(false);

			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;
			Slider.CURSOR_COLOR=0x222222;
			Slider.LINE_COLOR=0x444444;
			Slider.TEXT_COLOR=0x444444;

			_Slider1=new Slider();
			_Slider1.setMinMax(50, 800);
			_Slider1.setTitle("Distance caméra");
			_Slider1.create();
			_Slider1.setCursorPosition(800);
			
		}
		
		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 800});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .5, y: stage.stageHeight * .5});
			addChild(_View);

			_Camera.panAngle=-160;
			_Camera.tiltAngle=2;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);
			_NearfieldClipping=new NearfieldClipping();
			_RectangleClipping=new RectangleClipping();

			_View.clipping=_RectangleClipping;
			_View.clipping.minZ = 10;
					
		}

		private function initObjects():void
		{
			var plane1:Plane=new Plane();
			plane1.material=new WireColorMaterial(0xaa0000);
			plane1.rotationZ=90;
			plane1.scale(4);
			_View.scene.addChild(plane1);
		}

		private function onEnterFrame(event:Event):void
		{
			_Camera.hover();
			_View.render();
		}

		private function onMouseWheel(event:MouseEvent):void
		{
			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 150)
			{
				_Camera.distance=150;
			}
			_View.render();
			trace(_Camera.distance);
		}

		public function onCheckBoxStateChange(ThisCheckBox:CheckBox):void
		{
			switch (ThisCheckBox)
			{
				case _Checkbox1:

					if (ThisCheckBox.getState() == true)
					{
						_View.clipping=_RectangleClipping;
					}

					break

				case _Checkbox2:

					if (ThisCheckBox.getState() == true)
					{
						_View.clipping=_NearfieldClipping;
					}
					break

			}
		}
		
		public function onSliderMove(ThisSlider:Slider):void
		{
			_Camera.distance = ThisSlider.getCursorPosition();
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
		}

	}
}