package
{

	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.cameras.lenses.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	import flash.geom.*;
	
	import flash.display.*;
	import flash.events.*;

	import objects.CameraObject;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="250")]
	public class anim2 extends Sprite implements ICheckBox
	{

		private var _Origin:Vector3D;

		//engine variables 1
		private var _Camera1:HoverCamera3D;
		private var _View1:SingleView;

		//engine variables 2
		private var _Camera2:HoverCamera3D;
		private var _View2:SingleView;

		// camera
		private var _Zoom:Number=1;
		private var _Focus:Number=300;
		private var _Distance:Number=500;
		private var _Angle:Number=0;
		private var _TargetObject:Object3D;

		//objects
		private var _CameraObject:CameraObject;
		private var _Sphere1_1:Sphere;
		private var _Sphere2_1:Sphere;
		private var _Sphere1_2:Sphere;
		private var _Sphere2_2:Sphere;

		// Controls
		private var _Checkbox1:CheckBox;
		private var _Checkbox2:CheckBox;

		public function anim2()
		{
			_Origin=new Vector3D(0, 0, 0);

			initEngine1();
			initEngine2();

			initObjects1();
			initObjects2();

			initControls1();

			_TargetObject=_Sphere1_1;

			initListeners();

		}

		private function onEnterFrame(event:Event):void
		{
			_Angle+=0.02;

			_Sphere1_1.x=500 * Math.cos(_Angle);
			_Sphere1_1.y=300 * Math.sin(_Angle);

			_Sphere2_1.x=-300 * Math.cos(-_Angle * 1.5);
			_Sphere2_1.y=200 * Math.cos(-_Angle * 1.5);
			_Sphere2_1.z=400 * Math.sin(-_Angle * 1.5);

			_Sphere1_2.x=500 * Math.cos(_Angle);
			_Sphere1_2.y=300 * Math.sin(_Angle);

			_Sphere2_2.x=-300 * Math.cos(-_Angle * 1.5);
			_Sphere2_2.y=200 * Math.cos(-_Angle * 1.5);
			_Sphere2_2.z=400 * Math.sin(-_Angle * 1.5);

			_Camera1.target=_TargetObject;
			_CameraObject.lookAt(_TargetObject.position);
			_CameraObject.yaw(90);

			_View1.View.render();
			_View2.View.render();

		}

		private function initEngine1():void
		{
			_Camera1=new HoverCamera3D({zoom: 5, focus: 300, distance: 2000});

			_View1=new SingleView(stage.stageWidth / 2, stage.stageHeight, 0, 0, _Camera1);
			_Camera1.distance=_Distance;
			_Camera1.zoom=_Zoom;
			_Camera1.focus=_Focus;
			_Camera1.z=500;
			_Camera1.y=500;

			_Camera1.panAngle=-120;
			_Camera1.tiltAngle=9.5;
			_Camera1.minTiltAngle=-90;
			_Camera1.hover(true);

			addChild(_View1);

		}

		private function initEngine2():void
		{
			_Camera2=new HoverCamera3D({zoom: 5, focus: 300, distance: 2000});

			_View2=new SingleView(stage.stageWidth / 2-1, stage.stageHeight, stage.stageWidth / 2, 0, _Camera2);
			_Camera2.z=2500;
			_Camera2.zoom=3;
			_Camera2.x=1000;
			_Camera2.y=1000;
			_Camera2.lookAt(_Origin);
			addChild(_View2);
		}

		private function initControls1():void
		{

			CheckBox.X_POS=20;
			CheckBox.Y_POS=20;
			CheckBox.Y_OFFSET=20;
			CheckBox.ORIENTATION=CheckBox.LEFT;
			CheckBox.CALLBACK_INTERFACE=this;
			CheckBox.FONT_SIZE=12;

			_Checkbox1=new CheckBox(this, true);
			_Checkbox1.setTitle("Sphere rouge");
			_Checkbox1.create();
			_Checkbox1.setState(true);

			_Checkbox2=new CheckBox(this, true);
			_Checkbox2.setTitle("Sphere bleu");
			_Checkbox2.create();
			_Checkbox2.setState(false);

		}

		private function initObjects1():void
		{

			_Sphere1_1=new Sphere();
			_Sphere1_1.radius=50;
			_Sphere1_1.x=0;
			_Sphere1_1.y=0;
			_Sphere1_1.z=0;
			_Sphere1_1.material=new WireColorMaterial(0xff0000);
			_View1.View.scene.addChild(_Sphere1_1);

			_Sphere2_1=new Sphere();
			_Sphere2_1.radius=50;
			_Sphere2_1.y=-100;
			_Sphere2_1.z=-200;
			_Sphere2_1.material=new WireColorMaterial(0x0000ff);
			_View1.View.scene.addChild(_Sphere2_1);
		}

		private function initObjects2():void
		{
			_Sphere1_2=new Sphere();
			_Sphere1_2.radius=50;
			_Sphere1_2.x=0;
			_Sphere1_2.y=0;
			_Sphere1_2.z=0;
			_Sphere1_2.material=new WireColorMaterial(0xff0000);
			_View2.View.scene.addChild(_Sphere1_2);

			_Sphere2_2=new Sphere();
			_Sphere2_2.radius=50;
			_Sphere2_2.y=-100;
			_Sphere2_2.z=-200;
			_Sphere2_2.material=new WireColorMaterial(0x0000ff);
			_View2.View.scene.addChild(_Sphere2_2);

			_CameraObject=new CameraObject();
			_CameraObject.x=_Camera1.x;
			_CameraObject.y=_Camera1.y;
			_CameraObject.z=_Camera1.z;
			_CameraObject.material=new WireColorMaterial(0xcc8800);
			_CameraObject.lookAt(_Origin);
			_CameraObject.bothsides=true;
			_CameraObject.yaw(90);
			_CameraObject.scale(5);
			_CameraObject.moveRight(50);
			_View2.View.scene.addChild(_CameraObject);

		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);

		}

		public function onCheckBoxStateChange(ThisCheckBox:CheckBox):void
		{
			switch (ThisCheckBox)
			{
				case _Checkbox1:
					_TargetObject=_Sphere1_1;
					break;

				case _Checkbox2:
					_TargetObject=_Sphere2_1;
					break;

			}
		}

	}
}

