package
{
	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.cameras.lenses.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	import away3d.core.render.Renderer;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	
	import objects.CameraObject;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="250")]
	public class anim3 extends Sprite
	{

		private var _Origin:Vector3D;

		//engine variables 1
		private var _Camera1:HoverCamera3D;
		private var _View1:SingleView;

		//engine variables 2
		private var _Camera2:HoverCamera3D;
		private var _View2:SingleView;

		// camera
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;

		//objects
		private var _CameraObject:CameraObject;

		public function anim3()
		{
			_Origin=new Vector3D(0, 0, 0);

			initEngine1();
			initEngine2();

			initObjects1();
			initObjects2();

			initListeners();

			_View1.View.render();
			_View2.View.render();

		}

		private function initEngine1():void
		{
			_Camera1=new HoverCamera3D({zoom: 5, focus: 300, distance: 2000});

			_View1=new SingleView(stage.stageWidth / 2, stage.stageHeight, 0, 0, _Camera1);
			_Camera1.distance=500;
			_Camera1.zoom=1;
			_Camera1.lookAt(_Origin);

			_Camera1.panAngle=-120;
			_Camera1.tiltAngle=9.5;
			_Camera1.minTiltAngle=-90;
			_Camera1.hover(true);
			_Camera1.steps=8;
			addChild(_View1);

		}

		private function initEngine2():void
		{
			_Camera2=new HoverCamera3D({focus: 300, distance: 2000});

			_View2=new SingleView(stage.stageWidth / 2-1, stage.stageHeight, stage.stageWidth / 2, 0, _Camera2);
			_Camera2.z=3500;
			_Camera2.zoom=3;
			_Camera2.y=2000;
			_Camera2.lookAt(_Origin);
			_View2.View.renderer=Renderer.CORRECT_Z_ORDER;
			addChild(_View2);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);

		}

		private function onMouseDown(event:MouseEvent):void
		{
			if (stage.mouseX > stage.stageWidth / 2)
			{
				return;
			}

			_LastPanAngle=_Camera1.panAngle;
			_LastTiltAngle=_Camera1.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;

			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);

		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;

			stage.removeEventListener(MouseEvent.MOUSE_UP, onMouseUp);

		}

		private function onEnterFrame(event:Event):void
		{
			if (_Moving)
			{
				_Camera1.panAngle=0.5 * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera1.tiltAngle=0.5 * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}
			
			_Camera1.hover();
			_CameraObject.x=_Camera1.x;
			_CameraObject.y=_Camera1.y;
			_CameraObject.z=_Camera1.z;	
			_CameraObject.rotationX=_Camera1.rotationX;
			_CameraObject.rotationY=_Camera1.rotationY;
			_CameraObject.rotationZ=_Camera1.rotationZ;
			
						
			_CameraObject.lookAt(_Origin);
			_CameraObject.yaw(90);
			_CameraObject.moveRight(50);
			
			_View1.View.render();
			_View2.View.render();		
			
		}

		private function initObjects1():void
		{

			var sphere1:Sphere=new Sphere();
			var sphere2:Sphere=new Sphere();
			var sphere3:Sphere=new Sphere();
			var sphere4:Sphere=new Sphere();
			var sphere5:Sphere=new Sphere();
			var sphere6:Sphere=new Sphere();
			var sphere7:Sphere=new Sphere();
			var sphere8:Sphere=new Sphere();

			sphere1.radius=50;
			sphere1.x=0;
			sphere1.y=0;
			sphere1.z=0;
			sphere1.material=new WireColorMaterial(0x0000ff);
			_View1.View.scene.addChild(sphere1);

			sphere2.radius=50;
			sphere2.y=-100;
			sphere2.z=-200;
			sphere2.material=new WireColorMaterial(0x00bbff);
			_View1.View.scene.addChild(sphere2);

			sphere3.radius=70;
			sphere3.x=-300;
			sphere3.y=100;
			sphere3.z=500;
			sphere3.material=new WireColorMaterial(0xdd2200);
			_View1.View.scene.addChild(sphere3);

			sphere4.radius=40;
			sphere4.x=200;
			sphere4.y=95;
			sphere4.z=0;
			sphere4.material=new WireColorMaterial(0xff11bb);
			_View1.View.scene.addChild(sphere4);

			sphere5.radius=20;
			sphere5.x=50;
			sphere5.y=80;
			sphere5.z=-1000;
			sphere5.material=new WireColorMaterial(0x00bb00);
			_View1.View.scene.addChild(sphere5);

			sphere6.radius=60;
			sphere6.x=400;
			sphere6.y=-60;
			sphere6.z=900;
			sphere6.material=new WireColorMaterial(0x0b0b00);
			_View1.View.scene.addChild(sphere6);

			sphere7=new Sphere();
			sphere7.radius=40;
			sphere7.x=300;
			sphere7.y=50;
			sphere7.z=300;
			sphere7.material=new WireColorMaterial(0x0bb000);
			_View1.View.scene.addChild(sphere7);

			sphere8=new Sphere();
			sphere8.radius=70;
			sphere8.x=-200;
			sphere8.y=100;
			sphere8.z=-400;
			sphere8.material=new WireColorMaterial(0x0bb0e0);
			_View1.View.scene.addChild(sphere8);

		}

		private function initObjects2():void
		{

			var sphere1:Sphere=new Sphere();
			var sphere2:Sphere=new Sphere();
			var sphere3:Sphere=new Sphere();
			var sphere4:Sphere=new Sphere();
			var sphere5:Sphere=new Sphere();
			var sphere6:Sphere=new Sphere();
			var sphere7:Sphere=new Sphere();
			var sphere8:Sphere=new Sphere();

			sphere1.radius=50;
			sphere1.x=0;
			sphere1.y=0;
			sphere1.z=0;
			sphere1.material=new WireColorMaterial(0x0000ff);
			_View2.View.scene.addChild(sphere1);

			sphere2.radius=50;
			sphere2.y=-100;
			sphere2.z=-200;
			sphere2.material=new WireColorMaterial(0x00bbff);
			_View2.View.scene.addChild(sphere2);

			sphere3.radius=70;
			sphere3.x=-300;
			sphere3.y=100;
			sphere3.z=500;
			sphere3.material=new WireColorMaterial(0xdd2200);
			_View2.View.scene.addChild(sphere3);

			sphere4.radius=40;
			sphere4.x=200;
			sphere4.y=95;
			sphere4.z=0;
			sphere4.material=new WireColorMaterial(0xff11bb);
			_View2.View.scene.addChild(sphere4);

			sphere5.radius=20;
			sphere5.x=50;
			sphere5.y=80;
			sphere5.z=-1000;
			sphere5.material=new WireColorMaterial(0x00bb00);
			_View2.View.scene.addChild(sphere5);

			sphere6.radius=60;
			sphere6.x=400;
			sphere6.y=-60;
			sphere6.z=900;
			sphere6.material=new WireColorMaterial(0x0b0b00);
			_View2.View.scene.addChild(sphere6);

			sphere7.radius=40;
			sphere7.x=300;
			sphere7.y=50;
			sphere7.z=300;
			sphere7.material=new WireColorMaterial(0x0bb000);
			_View2.View.scene.addChild(sphere7);

			sphere8.radius=70;
			sphere8.x=-200;
			sphere8.y=100;
			sphere8.z=-400;
			sphere8.material=new WireColorMaterial(0x0bb0e0);
			_View2.View.scene.addChild(sphere8);

			_CameraObject=new CameraObject();
			_CameraObject.bothsides=true;
			_View2.View.scene.addChild(_CameraObject);
			_CameraObject.y=500;
			_CameraObject.z=500;
			_CameraObject.scaleX=5;

			_CameraObject.scaleY=4;
			_CameraObject.scaleZ=4;
			_CameraObject.material=new WireColorMaterial(0xcc8800);
			_CameraObject.lookAt(_Origin);
			_CameraObject.yaw(90);

		}
	}
}

