package
{

	import flash.geom.Vector3D;
	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.cameras.lenses.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;

	import objects.CameraObject;

	[SWF(backgroundColor="#000000", frameRate="30", quality="LOW", width="570", height="250")]
	public class anim4 extends Sprite implements ISlider, ICheckBox
	{

		private var _Origin:Vector3D;

		//engine variables 1
		private var _Camera1:SpringCam;
		private var _View1:SingleView;

		//engine variables 2
		private var _Camera2:HoverCamera3D;
		private var _View2:SingleView;
		private var _Angle:Number=0;

		//objects
		private var _CameraObject:CameraObject;
		private var _Sphere1_1:Sphere;
		private var _Sphere1_2:Sphere;
		private var _Skybox1:Skybox;
		private var _Skybox2:Skybox;

		private var _ObjectMoving:Boolean=false;

		// Controls
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Checkbox1:CheckBox;

		//cameras
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;

		[Embed(source="assets/skybox/XN.jpg")]
		private var _left2:Class;

		[Embed(source="assets/skybox/XP.jpg")]
		private var _right2:Class;

		[Embed(source="assets/skybox/YP.jpg")]
		private var _top2:Class;

		[Embed(source="assets/skybox/YN.jpg")]
		private var _bottom2:Class;

		[Embed(source="assets/skybox/ZP.jpg")]
		private var _back2:Class;

		[Embed(source="assets/skybox/ZN.jpg")]
		private var _front2:Class;

		public function anim4()
		{
			_Origin=new Vector3D(0, 0, 0);

			initEngine1();
			initEngine2();

			initObjects1();
			initObjects2();

			initControls1();

			initListeners();

			UpdateObjectPosition();
		}

		private function UpdateObjectPosition():void
		{

			_Angle+=0.08;

			_Sphere1_2.x=_Sphere1_1.x=500 * Math.cos(_Angle);
			_Sphere1_2.z=_Sphere1_1.z=500 * Math.sin(_Angle);
			_Sphere1_2.lookAt(this._Origin);
			_Sphere1_1.lookAt(this._Origin);

			_Camera1.view;

			_CameraObject.x=_Camera1.x;
			_CameraObject.y=_Camera1.y;
			_CameraObject.z=_Camera1.z;

			_CameraObject.rotationX=_Camera1.rotationX;
			_CameraObject.rotationY=_Camera1.rotationY;
			_CameraObject.rotationZ=_Camera1.rotationZ;

			_CameraObject.yaw(90);
			_View1.View.render();

		}

		private function onEnterFrame(event:Event):void
		{

			var cameraSpeed:Number=0.5;

			if (_Moving)
			{
				_Camera2.panAngle=0.5 * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera2.tiltAngle=0.5 * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}

			if (_ObjectMoving)
			{
				UpdateObjectPosition();
				_View1.View.render();
			}

			_Camera2.hover();
			_View2.View.render();

		}

		private function initEngine1():void
		{
			_Camera1=new SpringCam();
			_Camera1.mass=15;
			_Camera1.damping=3;
			_Camera1.stiffness=0.1;

			_Camera1.positionOffset=new Vector3D(0, 0, -500);

			_View1=new SingleView(stage.stageWidth / 2-1, stage.stageHeight, stage.stageWidth / 2, 0, _Camera1);

			addChild(_View1);

		}

		private function initEngine2():void
		{
			_Camera2=new HoverCamera3D({focus: 300, distance: 2000});

			_View2=new SingleView(stage.stageWidth / 2, stage.stageHeight, 0, 0, _Camera2);

			_Camera2.z=3500;
			_Camera2.zoom=1.5;
			_Camera2.x=1000;
			_Camera2.y=1000;
			_Camera2.lookAt(_Origin);

			_Camera2.panAngle=-120;
			_Camera2.tiltAngle=19.5;
			_Camera2.minTiltAngle=-90;
			_Camera2.hover(true);
			addChild(_View2);
		}

		private function initControls1():void
		{

			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.TEXT_COLOR=0xffffff;
			Slider.LINE_COLOR=0x999999;
			Slider.CURSOR_COLOR=0xbbbbbb;

			_Slider1=new Slider();
			_Slider1.setMinMax(5, 200);
			_Slider1.setTitle("mass");
			_Slider1.create();
			_Slider1.setCursorPosition(15);

			_Slider2=new Slider();
			_Slider2.setMinMax(2, 10);
			_Slider2.setTitle("damping");
			_Slider2.create();
			_Slider2.setCursorPosition(3);

			_Slider3=new Slider();
			_Slider3.setMinMax(0.2, 0.8, 2);
			_Slider3.setTitle("stiffness");
			_Slider3.create();
			_Slider3.setCursorPosition(0.2);

			CheckBox.X_POS=260;
			CheckBox.Y_POS=20;
			CheckBox.Y_OFFSET=20;
			CheckBox.ORIENTATION=CheckBox.RIGHT;
			CheckBox.CALLBACK_INTERFACE=this;
			CheckBox.FONT_SIZE=12;
			CheckBox.SQUARE_COLOR=0x999999;
			CheckBox.TICK_COLOR=0xbbbbbb;
			CheckBox.TITLE_COLOR=0xffffff;

			_Checkbox1=new CheckBox(this, false);
			_Checkbox1.setTitle("mouvement");
			_Checkbox1.create();
			_Checkbox1.setState(false);
		}

		private function initObjects1():void
		{

			_Sphere1_1=new Sphere();
			_Sphere1_1.radius=30;
			_Sphere1_1.x=0;
			_Sphere1_1.y=0;
			_Sphere1_1.z=0;
			_Sphere1_1.material=new WireColorMaterial(0xff0000);
			_View1.View.scene.addChild(_Sphere1_1);

			_Skybox1=new Skybox(new BitmapMaterial(Cast.bitmap(_back2)), new BitmapMaterial(Cast.bitmap(_left2)), new BitmapMaterial(Cast.bitmap(_front2)), new BitmapMaterial(Cast.bitmap(_right2)), new BitmapMaterial(Cast.bitmap(_top2)), new BitmapMaterial(Cast.bitmap(_bottom2)));
			_Skybox1.scale(0.01);
			_View1.View.scene.addChild(_Skybox1);
		}

		private function initObjects2():void
		{

			_Sphere1_2=new Sphere();
			_Sphere1_2.radius=50;
			_Sphere1_2.x=0;
			_Sphere1_2.y=0;
			_Sphere1_2.z=0;
			_Sphere1_2.material=new WireColorMaterial(0xff0000);
			_View2.View.scene.addChild(_Sphere1_2);

			_Skybox2=new Skybox(new BitmapMaterial(Cast.bitmap(_back2)), new BitmapMaterial(Cast.bitmap(_left2)), new BitmapMaterial(Cast.bitmap(_front2)), new BitmapMaterial(Cast.bitmap(_right2)), new BitmapMaterial(Cast.bitmap(_top2)), new BitmapMaterial(Cast.bitmap(_bottom2)));
			_Skybox2.scale(0.08);
			_View2.View.scene.addChild(_Skybox2);

			_Camera1.target=_Sphere1_1;
			_CameraObject=new CameraObject();
			_CameraObject.x=_Camera1.x;
			_CameraObject.y=_Camera1.y;
			_CameraObject.z=_Camera1.z;

			_CameraObject.bothsides=true;
			_CameraObject.material=new WireColorMaterial(0xcc8800);
			_CameraObject.lookAt(_Origin);
			_CameraObject.yaw(90);
			_CameraObject.scale(5);

			_View2.View.scene.addChild(_CameraObject);

		}

		private function onMouseWheel(event:MouseEvent):void
		{
			if (stage.mouseX > stage.stageWidth / 2)
			{
				return;
			}

			_Camera2.distance+=-event.delta * 10;

			if (_Camera2.distance < 100)
			{
				_Camera2.distance=50;
			}

		}

		private function onMouseDown(event:MouseEvent):void
		{
			if (stage.mouseX > stage.stageWidth / 2)
			{
				return;
			}

			_LastPanAngle=_Camera2.panAngle;
			_LastTiltAngle=_Camera2.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;

			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);

		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;

			stage.removeEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.removeEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);

		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);

		}

		// override ISlider's properties
		public function onSliderMove(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_Camera1.mass=ThisSlider.getCursorPosition();
					break;
				case _Slider2:
					_Camera1.damping=ThisSlider.getCursorPosition();
					break;
				case _Slider3:
					_Camera1.stiffness=ThisSlider.getCursorPosition();
					break;

			}
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{

		}

		public function onCheckBoxStateChange(ThisCheckBox:CheckBox):void
		{
			this._ObjectMoving=ThisCheckBox.getState();
		}

	}
}

