package
{

	import away3d.cameras.lenses.OrthogonalLens;
	import away3d.cameras.lenses.SphericalLens;
	import away3d.cameras.lenses.ZoomFocusLens;
	import SGComponents.*;

	import away3d.animators.*;
	import away3d.animators.data.*;
	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.lights.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	import away3d.core.render.Renderer;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="350")]
	public class anim5 extends Sprite implements ICheckBox
	{

		//engine variables
		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;
		private var _Checkbox1:CheckBox;
		private var _Checkbox2:CheckBox;
		private var _Checkbox3:CheckBox;

		public function anim5()
		{
			initEngine();
			initObjects();
			initControls();
			initListeners();
		}

		public function initControls():void
		{
			CheckBox.X_POS=20;
			CheckBox.Y_POS=20;
			CheckBox.Y_OFFSET=20;
			CheckBox.CALLBACK_INTERFACE=this;
			CheckBox.FONT_SIZE=12;

			_Checkbox1=new CheckBox(this, true);
			_Checkbox1.setTitle("ZoomFocusLens ");
			_Checkbox1.create();
			_Checkbox1.setState(true);

			_Checkbox2=new CheckBox(this, true);
			_Checkbox2.setTitle("SphericalLens ");
			_Checkbox2.create();
			_Checkbox2.setState(false);

			_Checkbox3=new CheckBox(this, true);
			_Checkbox3.setTitle("OrthogonalLens ");
			_Checkbox3.create();
			_Checkbox3.setState(false);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 10, focus: 30, distance: 900});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .5, y: stage.stageHeight * .5});
		
			addChild(_View);

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);

		}

		private function initObjects():void
		{

			_View.scene.addChild(new Cube({x: -50, y: 0, z: -200, material: new WireColorMaterial(0x990000)}));
			_View.scene.addChild(new Sphere({x: 100, y: 200, z: -400, material: new WireColorMaterial(0x009900)}));
			_View.scene.addChild(new Cube({x: -100, y: 0, z: 500, material: new WireColorMaterial(0x000099)}));
			_View.scene.addChild(new Sphere({x: 100, y: -200, z: 300, material: new WireColorMaterial(0xbb00bb)}));
			_View.scene.addChild(new Cube({x: -100, y: 100, z: 1000, material: new WireColorMaterial(0x00bbbb)}));
			_View.scene.addChild(new Cylinder({x: -300, y: -300, z: 1000, material: new WireColorMaterial(0xf0f0bb)}));
			_View.scene.addChild(new Cylinder({x: 600, y: -300, z: 1000, material: new WireColorMaterial(0x999900)}));

		}

		private function onMouseWheel(event:MouseEvent):void
		{
			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}
		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{
			var cameraSpeed:Number=0.5;

			if (_Moving)
			{
				_Camera.panAngle=cameraSpeed * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=cameraSpeed * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}

			_Camera.hover();
			_View.render();
		}

		public function onCheckBoxStateChange(ThisCheckBox:CheckBox):void
		{

			switch (ThisCheckBox)
			{
				case _Checkbox1:
					_Camera.lens=new ZoomFocusLens();

					break;

				case _Checkbox2:
					_Camera.lens=new SphericalLens();

					break;

				case _Checkbox3:
					_Camera.lens=new OrthogonalLens();
					_Camera.zoom=10;
					_Camera.focus=30;
					break;
			}
		}
	}
}

