package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	
	
	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="250")]
	public class anim1 extends Sprite implements ISlider
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		//objects
		private var _Plane:Plane;

		// Sliders		
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Slider5:Slider;

		public function anim1()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 28, focus: 3000, distance: 1800});

			_View=new View3D({_Camera: _Camera, x:stage.stageWidth * .6, y: stage.stageHeight * .5});

			addChild(_View);

			_Camera.lookAt(new Vector3D(0, 0, 0));
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;

			_Slider1=new Slider();
			_Slider1.setMinMax(20, 150);
			_Slider1.setTitle("width");
			_Slider1.create();
			_Slider1.setCursorPosition(100);

			_Slider2=new Slider();
			_Slider2.setMinMax(20, 150);
			_Slider2.setTitle("heght");
			_Slider2.create();
			_Slider2.setCursorPosition(100);

			_Slider3=new Slider();
			_Slider3.setMinMax(1, 6);
			_Slider3.setTitle("segmentsW");
			_Slider3.create();
			_Slider3.setCursorPosition(1);

			_Slider4=new Slider();
			_Slider4.setMinMax(1, 6);
			_Slider4.setTitle("segmentsH");
			_Slider4.create();
			_Slider4.setCursorPosition(1);

			_Slider5=new Slider();
			_Slider5.setMinMax(0, 1);
			_Slider5.setWidth(20);
			_Slider5.setTitle("bothsides");
			_Slider5.create();
			_Slider5.setCursorPosition(1);

		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_Plane.width=ThisSlider.getCursorPosition();
					break;
				case _Slider2:
					_Plane.height=ThisSlider.getCursorPosition();
					break;
				case _Slider3:
					_Plane.segmentsW=ThisSlider.getCursorPosition();
					break;
				case _Slider4:
					_Plane.segmentsH=ThisSlider.getCursorPosition();
					break;
				case _Slider5:
					_Plane.bothsides=Boolean(ThisSlider.getCursorPosition());

					break;
			}
		}

		private function initObjects():void
		{
			_Plane=new Plane();
			_Plane.width=100;
			_Plane.height=100;
			_Plane.segmentsH=1;
			_Plane.segmentsW = 1;
			_Plane.scale(2);
			_Plane.x=-5;
			_Plane.y=10;
			_Plane.rotationX = -90;
			_Plane.bothsides=true;
			_Plane.material=new WireColorMaterial(0xF4661B);
			_View.scene.addChild(_Plane);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_Plane.rotationY+=3;

			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

	}
}