package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="250")]
	public class anim3 extends Sprite implements ISlider
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		//objects
		private var _Shere:Sphere;

		// Sliders		
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;

		public function anim3()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 18, focus: 2000, distance: 18000});

			_View=new View3D({_Camera: _Camera, x: stage.stageWidth * .6, y: stage.stageHeight * .5});

			addChild(_View);

			_Camera.lookAt(new Vector3D(0, 0, 0));

		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider1=new Slider();
			_Slider1.setMinMax(0, 80);
			_Slider1.setTitle("Radius");
			_Slider1.create();
			_Slider1.setCursorPosition(50);

			_Slider2=new Slider();
			_Slider2.setMinMax(1, 15);
			_Slider2.setTitle("segmentsW");
			_Slider2.create();
			_Slider2.setCursorPosition(7);

			_Slider3=new Slider();
			_Slider3.setMinMax(1, 15);
			_Slider3.setTitle("segmentsH");
			_Slider3.create();
			_Slider3.setCursorPosition(7);
		}

		private function initObjects():void
		{
			_Shere=new Sphere();
			_Shere.radius=50;
			_Shere.segmentsH=15;
			_Shere.segmentsW = 15;
			_Shere.scale(2);
			_Shere.x=-10;
			_Shere.y=10;
			_Shere.material=new WireColorMaterial(0xF4661B);

			_View.scene.addChild(_Shere);
		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_Shere.radius=ThisSlider.getCursorPosition();
					break;
				case _Slider2:
					_Shere.segmentsW=ThisSlider.getCursorPosition();
					break;
				case _Slider3:
					_Shere.segmentsH=ThisSlider.getCursorPosition();
					break;
			}
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_Shere.rotationY+=2;

			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

	}
}