package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="250")]
	public class anim4 extends Sprite implements ISlider
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		
		//objects
		private var _Cylinder:Cylinder;

		// Sliders		
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;

		public function anim4()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 18, focus: 2000, distance: 18000});

			_View=new View3D({_Camera: _Camera, x: stage.stageWidth * .6, y: stage.stageHeight * .5});

			addChild(_View);

			_Camera.lookAt(new Vector3D(0, 0, 0));

		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider1=new Slider();
			_Slider1.setMinMax(20, 100);
			_Slider1.setTitle("Radius");
			_Slider1.create();
			_Slider1.setCursorPosition(70);

			_Slider2=new Slider();
			_Slider2.setMinMax(40, 150);
			_Slider2.setTitle("heigth");
			_Slider2.create();
			_Slider2.setCursorPosition(80);

			_Slider3=new Slider();
			_Slider3.setMinMax(1, 15);
			_Slider3.setTitle("segmentsW");
			_Slider3.create();
			_Slider3.setCursorPosition(5);

			_Slider4=new Slider();
			_Slider4.setMinMax(1, 15);
			_Slider4.setTitle("segmentsH");
			_Slider4.create();
			_Slider4.setCursorPosition(5);
		}

		private function initObjects():void
		{
			_Cylinder=new Cylinder();
			_Cylinder.radius=70;
			_Cylinder.height=80;
			_Cylinder.segmentsH=5;
			_Cylinder.segmentsW=5;
			_Cylinder.x=-10;
			_Cylinder.y = 10;
			_Cylinder.scale(2);
			_Cylinder.material=new WireColorMaterial(0xF4661B);

			_View.scene.addChild(_Cylinder);
		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_Cylinder.radius=ThisSlider.getCursorPosition();
					_Cylinder.height=_Slider2.getCursorPosition();
					break;
				case _Slider2:
					_Cylinder.height=ThisSlider.getCursorPosition();
					break;
				case _Slider3:
					_Cylinder.segmentsW=ThisSlider.getCursorPosition();
					_Cylinder.height=_Slider2.getCursorPosition();
					break;
				case _Slider4:
					_Cylinder.segmentsH=ThisSlider.getCursorPosition();
					_Cylinder.height=_Slider2.getCursorPosition();
					break;
			}
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_Cylinder.rotationY+=1;

			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

	}
}