﻿package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	import away3d.core.clip.*;
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#000000", frameRate="30", quality="HIGH", width="570", height="280")]
	public class anim5 extends Sprite
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		//objects
		private var _Skybox:Skybox;

		private var _Moving:Boolean=false;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;

		[Embed(source="assets/skybox/XN.jpg")]
		private var _xn:Class;

		[Embed(source="assets/skybox/XP.jpg")]
		private var _xp:Class;

		[Embed(source="assets/skybox/YP.jpg")]
		private var _yp:Class;

		[Embed(source="assets/skybox/YN.jpg")]
		private var _yn:Class;

		[Embed(source="assets/skybox/ZP.jpg")]
		private var _zp:Class;

		[Embed(source="assets/skybox/ZN.jpg")]
		private var _zn:Class;

		public function anim5()
		{
			initEngine();
			initObjects();
			initListeners();
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D();
			_Camera.panAngle=0;
			_Camera.tiltAngle=0;
			_Camera.minTiltAngle=-90;
			
			_View=new View3D({_Camera: _Camera, x: stage.stageWidth * .6, y: stage.stageHeight * .5});
			_View.scene=_Scene;
			_View.camera=_Camera;
			


			addChild(_View);

			
			_Camera.hover(true);
		}

		private function initObjects():void
		{
			// create skybox from materials
			_Skybox=new Skybox(new BitmapMaterial(Cast.bitmap(_zp)), new BitmapMaterial(Cast.bitmap(_xn)), new BitmapMaterial(Cast.bitmap(_zn)), new BitmapMaterial(Cast.bitmap(_xp)), new BitmapMaterial(Cast.bitmap(_yp)), new BitmapMaterial(Cast.bitmap(_yn)));
			_Skybox.scale(0.01);

			_View.scene.addChild(_Skybox);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;

			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
			stage.removeEventListener(MouseEvent.MOUSE_UP, onMouseUp);
		}

		private function onEnterFrame(e:Event):void
		{
			if (_Moving)
			{
				_Camera.panAngle=0.5 * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=0.5 * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}
			_Camera.hover();
			_View.render();

		}

	}
}