package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.geom.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.extrusions.PathExtrusion;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="300")]
	public class anim1 extends Sprite implements ISlider
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		//objects
		private var _PathExtrusion:PathExtrusion;

		// Sliders		
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Slider5:Slider;
		private var _Slider6:Slider;

		private var _Flip:Boolean=false;
		private var _Aligntopath:Boolean=true;
		private var _Coverall:Boolean=true;
		private var _Closepath:Boolean=false;
		private var _Subdivision:Number=8;
		private var _BothSide:Boolean=true;

		private var _CrossSection:Array=[];
		private var _Path:Path;

		private var _YRotation:Number=0;

		public function anim1()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 5, focus: 2000, distance: 180});
			_Camera.lookAt(new Vector3D(0, 0, 0));

			_View=new View3D({_Camera: _Camera, x: 290, y: 190});
			_View.scene=_Scene;

			addChild(_View);

		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider2=new Slider();
			_Slider2.setMinMax(1, 30);
			_Slider2.setTitle("subdivision");
			_Slider2.create();
			_Slider2.setCursorPosition(8);

			Slider.CONTROL_WIDTH=20;

			_Slider5=new Slider();
			_Slider5.setMinMax(0, 1);
			_Slider5.setTitle("bothsides");
			_Slider5.create();
			_Slider5.setCursorPosition(1);

			_Slider3=new Slider();
			_Slider3.setMinMax(0, 1);
			_Slider3.setTitle("flip");
			_Slider3.create();
			_Slider3.setCursorPosition(0);

			_Slider4=new Slider();
			_Slider4.setMinMax(0, 1);
			_Slider4.setTitle("aligntopath");
			_Slider4.create();
			_Slider4.setCursorPosition(1);

			_Slider6=new Slider();
			_Slider6.setMinMax(0, 1);
			_Slider6.setTitle("closepath");
			_Slider6.create();
			_Slider6.setCursorPosition(0);
		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider2:
					_Subdivision=ThisSlider.getCursorPosition();
					break;
				case _Slider3:
					_Flip=ThisSlider.getCursorPosition() == 1;
					break;
				case _Slider4:
					_Aligntopath=ThisSlider.getCursorPosition() == 1;
					break;
				case _Slider5:
					_BothSide=ThisSlider.getCursorPosition() == 1;
					break;
				case _Slider6:
					_Closepath=ThisSlider.getCursorPosition() == 1;
					break;
			}
		}

		private function initObjects():void
		{
			_Path=new Path([new Vector3D(-400, 500, -150), new Vector3D(0, 0, 0), new Vector3D(300, 500, 0),]);

			_CrossSection.push(new Vector3D(-100, 0, 0));
			_CrossSection.push(new Vector3D(-50, 0, 0));
			_CrossSection.push(new Vector3D(-50, -50, 0));
			_CrossSection.push(new Vector3D(0, -50, 0));
			_CrossSection.push(new Vector3D(50, -50, 0));
			_CrossSection.push(new Vector3D(50, 0, 0));
			_CrossSection.push(new Vector3D(100, 0, 0));

			var mat:WireColorMaterial=new WireColorMaterial(0xF4661B);
			_PathExtrusion=new PathExtrusion(_Path, _CrossSection, null, null, {flip: _Flip, alignToPath: _Aligntopath, coverall: _Coverall, closePath: _Closepath, material: mat, subdivision: _Subdivision});

			_View.scene.addChild(_PathExtrusion);
			_PathExtrusion.x=60;
			_PathExtrusion.y=-100;
			_PathExtrusion.scale(0.4);
			_PathExtrusion.bothsides=_BothSide;
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_PathExtrusion.rotationY+=1;
			_YRotation=_PathExtrusion.rotationY;
			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{

		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
			_View.scene.removeChild(_PathExtrusion);
			var mat:WireColorMaterial=new WireColorMaterial(0xF4661B);
			_PathExtrusion=new PathExtrusion(_Path, _CrossSection, null, null, {flip: _Flip, alignToPath: _Aligntopath, coverall: _Coverall, closePath: _Closepath, material: mat, subdivision: _Subdivision});
			_View.scene.addChild(_PathExtrusion);
			_PathExtrusion.rotationY=_YRotation;
			_PathExtrusion.x=60;
			_PathExtrusion.y=-100;
			_PathExtrusion.scale(0.4);
			_PathExtrusion.bothsides=_BothSide;
		}

	}
}