package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.geom.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.extrusions.PathExtrusion;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="240")]
	public class anim2 extends Sprite implements ISlider
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		//objects
		private var _PathExtrusion:PathExtrusion;

		// Sliders		
		private var _Slider1:Slider;

		private var _Flip:Boolean=false;
		private var _Aligntopath:Boolean=true;
		private var _Coverall:Boolean=true;
		private var _Closepath:Boolean=false;
		private var _Subdivision:Number=8;

		private var _CrossSection:Array=[];
		private var _Path:Path;

		private var _Smoothscale:Boolean=true;

		private var _YRotation:Number=0;

		public function anim2()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 5, focus: 2000, distance: 180});
			_Camera.lookAt(new Vector3D(0, 0, 0));

			_View=new View3D({_Camera: _Camera, x: 285, y: 200});
			_View.scene=_Scene;

			addChild(_View);

		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=160;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			Slider.CONTROL_WIDTH=20;

			_Slider1=new Slider();
			_Slider1.setMinMax(0, 1);
			_Slider1.setTitle("smoothscale");
			_Slider1.create();
			_Slider1.setCursorPosition(1);

		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			_Smoothscale=ThisSlider.getCursorPosition() == 1;
		}

		private function initObjects():void
		{
			_Path=new Path([new Vector3D(-600, 500, 0), new Vector3D(-400, 100, 0), new Vector3D(0, 0, 0), new Vector3D(0, 0, 0), new Vector3D(400, 100, 0), new Vector3D(800, 500, 0), new Vector3D(800, 500, 0), new Vector3D(1200, 400, 0), new Vector3D(1400, 0, 0),]);

			_CrossSection.push(new Vector3D(-100, 0, 0));
			_CrossSection.push(new Vector3D(-50, 0, 0));
			_CrossSection.push(new Vector3D(-50, -50, 0));
			_CrossSection.push(new Vector3D(0, -50, 0));
			_CrossSection.push(new Vector3D(50, -50, 0));
			_CrossSection.push(new Vector3D(50, 0, 0));
			_CrossSection.push(new Vector3D(100, 0, 0));

			var aScale:Array=[];
			aScale.push(new Vector3D(1, 1, 4));
			aScale.push(new Vector3D(1, 1, 1));
			aScale.push(new Vector3D(1, 1, 4));

			var mat:WireColorMaterial=new WireColorMaterial(0xF4661B);
			_PathExtrusion=new PathExtrusion(_Path, _CrossSection, aScale, null, {smoothscale: _Smoothscale, flip: _Flip, alignToPath: _Aligntopath, coverAll: _Coverall, closePath: _Closepath, material: mat, subdivision: _Subdivision});
			_PathExtrusion.bothsides=true;
			_PathExtrusion.scale(0.18);
			_View.scene.addChild(_PathExtrusion);
			_PathExtrusion.x=0;
			_PathExtrusion.y=50;
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_PathExtrusion.rotationY+=1;
			_YRotation=_PathExtrusion.rotationY;
			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
			_View.scene.removeChild(_PathExtrusion);
			var aScale:Array=[];
			aScale.push(new Vector3D(1, 1, 4));
			aScale.push(new Vector3D(1, 1, 1));
			aScale.push(new Vector3D(1, 1, 4));
			aScale.push(new Vector3D(1, 1, 1));
			aScale.push(new Vector3D(1, 1, 0.1));

			var mat:WireColorMaterial=new WireColorMaterial(0xF4661B);
			_PathExtrusion=new PathExtrusion(_Path, _CrossSection, aScale, null, {smoothscale: _Smoothscale, flip: _Flip, alignToPath: _Aligntopath, coverAll: _Coverall, closePath: _Closepath, material: mat, subdivision: _Subdivision});
			_PathExtrusion.bothsides=true;
			_PathExtrusion.scale(0.18);
			_View.scene.addChild(_PathExtrusion);
			_PathExtrusion.rotationY=_YRotation;
			_PathExtrusion.x=0;
			_PathExtrusion.y=50;
		}

	}
}