package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.filter.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.extrusions.LatheExtrusion;
	import away3d.extrusions.PathExtrusion;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	import away3d.core.render.Renderer;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="280")]
	public class anim3 extends Sprite implements ISlider
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		// Sliders		
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Slider5:Slider;
		private var _Slider6:Slider;
		private var _Slider7:Slider;

		private var _Revolutions:Number=1;
		private var _Subdivision:Number=8;
		private var _Offsetradius:Number=0;
		private var _Coverall:Boolean=true;
		private var _Recenter:Boolean=true;
		private var _Bothsides:Boolean=true;
		private var _YRotation:Number=0;

		private var _Thickness:Number=0;

		private var _LatheExtrusion:LatheExtrusion;

		public function anim3()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 5, focus: 2000, distance: 180});
			_Camera.lookAt(new Vector3D(0, 0, 0));

			_View=new View3D({_Camera: _Camera, x: 270, y: 140});
			_View.scene=_Scene;

			addChild(_View);
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider2=new Slider();
			_Slider2.setMinMax(1, 30);
			_Slider2.setTitle("subdivision");
			_Slider2.create();
			_Slider2.setCursorPosition(8);

			_Slider3=new Slider();
			_Slider3.setMinMax(0, 1, 1);
			_Slider3.setTitle("revolutions");
			_Slider3.create();
			_Slider3.setCursorPosition(1);

			_Slider4=new Slider();
			_Slider4.setMinMax(0, 50);
			_Slider4.setTitle("thickness");
			_Slider4.create();
			_Slider4.setCursorPosition(0);

			_Slider6=new Slider();
			_Slider6.setMinMax(0, 50);
			_Slider6.setTitle("offsetRadius");
			_Slider6.create();
			_Slider6.setCursorPosition(0);

			Slider.CONTROL_WIDTH=20;

			_Slider5=new Slider();
			_Slider5.setMinMax(0, 1);
			_Slider5.setTitle("centerMesh");
			_Slider5.create();
			_Slider5.setCursorPosition(1);

			_Slider7=new Slider();
			_Slider7.setMinMax(0, 1);
			_Slider7.setTitle("bothsides");
			_Slider7.create();
			_Slider7.setCursorPosition(1);

		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider2:
					_Subdivision=ThisSlider.getCursorPosition();
					break;
				case _Slider3:
					_Revolutions=ThisSlider.getCursorPosition();
					break;
				case _Slider4:
					_Thickness=ThisSlider.getCursorPosition();
					break;
				case _Slider5:
					_Recenter=ThisSlider.getCursorPosition() == 1;
					break;
				case _Slider6:
					_Offsetradius=ThisSlider.getCursorPosition();
					break;
				case _Slider7:
					_Bothsides=ThisSlider.getCursorPosition() == 1;
					break;
			}
		}

		private function initObjects():void
		{
			var CrossSection:Array=[];
			CrossSection.push(new Vector3D(200, 250, 0));
			CrossSection.push(new Vector3D(300, 0, 0));
			CrossSection.push(new Vector3D(0, 0, 0));

			var mat:WireColorMaterial=new WireColorMaterial(0xF4661B);
			_LatheExtrusion=new LatheExtrusion(CrossSection, {material: mat, axis: "y", revolutions: _Revolutions, offsetRadius: _Offsetradius, thickness: _Thickness, subdivision: _Subdivision, coverall: _Coverall, bothsides: _Bothsides, centerMesh: _Recenter});
			_Scene.addChild(_LatheExtrusion);
			_LatheExtrusion.rotationX+=90;
			_LatheExtrusion.x = 80;
			_LatheExtrusion.y = 0;
			_LatheExtrusion.scale(0.3);

		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_LatheExtrusion.rotationY+=1;
			_YRotation = _LatheExtrusion.rotationY;
			_View.renderer = Renderer.CORRECT_Z_ORDER;
			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);

			_LatheExtrusion.material=null;
			_View.scene.removeChild(_LatheExtrusion);

			var CrossSection:Array=[];
			CrossSection.push(new Vector3D(200, 250, 0));
			CrossSection.push(new Vector3D(300, 0, 0));
			CrossSection.push(new Vector3D(0, 0, 0));

			var mat:WireColorMaterial=new WireColorMaterial(0xF4661B);
			_LatheExtrusion=new LatheExtrusion(CrossSection, {material: mat, axis: "y", revolutions: _Revolutions, offsetRadius: _Offsetradius, thickness: _Thickness, subdivision: _Subdivision, coverall: _Coverall, bothsides: _Bothsides, centerMesh: _Recenter});
			_Scene.addChild(_LatheExtrusion);
			_LatheExtrusion.rotationX+=90;
			_LatheExtrusion.x = 80;
			_LatheExtrusion.y = 0;
			_LatheExtrusion.scale(0.3);
			_LatheExtrusion.rotationY=_YRotation;
		}

	}
}