package
{
	
	import away3d.core.clip.NearfieldClipping;
	import SGComponents.*;
	
	import away3d.animators.*;
	import away3d.animators.data.*;
	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.render.Renderer;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.extrusions.*;
	import away3d.lights.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	
	
	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="400")]
	public class anim5 extends Sprite implements ISlider
	{

		[Embed(source="/assets/elevation.jpg")] private var _Elevation_map:Class;
   		private var elevationBitmap:Bitmap = new _Elevation_map();
   		
 
   		// control 
   		private var _SubdivisionX:Number = 100;
   		private var _SubdivisionY:Number = 100;
   		private var _FactorX:Number = 6;
   		private var _FactorY:Number = 6; 
   		private var _Elevate:Number=5;
   		
		//engine variables
		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;
		
		// Sliders		
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Slider5:Slider;
		
		private var _Extrude:SkinExtrude;
		private var _ElevationMap:BitmapData;
		private var _Terrain:BitmapData;
		private var _Elevation:Elevation;
		private var _Vertices:Array;
		private var _Material:BitmapMaterial;
		
		
		public function anim5()
		{	
			initEngine();
			initObjects();
			initSliders();
			initListeners();		
		}
		
		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER = stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS =20;
			Slider.Y_POS = 40;
			Slider.Y_OFFSET = 40;
			Slider.STICKY=true;
				
			_Slider1 = new Slider();								
			_Slider1.setMinMax(40,150);
			_Slider1.setTitle("subdivisionX");
			_Slider1.create();	
			_Slider1.setCursorPosition(_SubdivisionX);
				
			_Slider2 = new Slider();
			_Slider2.setMinMax(40,150);
			_Slider2.setTitle("subdivisionY");
			_Slider2.create();
			_Slider2.setCursorPosition(_SubdivisionY);
			
			_Slider3 = new Slider();
			_Slider3.setMinMax(1,10);
			_Slider3.setTitle("scalingX");
			_Slider3.create();
			_Slider3.setCursorPosition(_FactorX);
			
			_Slider4 = new Slider();
			_Slider4.setMinMax(1,10);
			_Slider4.setTitle("scalingY");
			_Slider4.create();
			_Slider4.setCursorPosition(_FactorY);
			
			_Slider5 = new Slider();
			_Slider5.setMinMax(1,10);
			_Slider5.setTitle("elevate");
			_Slider5.create();
			_Slider5.setCursorPosition(_Elevate);
		
		}			
		
		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}
		
		private function initEngine():void
		{
			_Camera= new HoverCamera3D({zoom:6, focus:100, distance:5000});

			_View = new View3D({camera:_Camera,x: stage.stageWidth*.55, y : stage.stageHeight*.4});
		
			addChild(_View);
			
			_Camera.panAngle = 160;
			_Camera.tiltAngle = 20;
			_Camera.minTiltAngle = -90;
			_Camera.hover(true);
		}
		
		private function generateElevationMap():void
		{
			if(_Vertices!=null){
				while(_Vertices.length!=0){_Vertices.pop();}
			}
			
			 _Vertices = _Elevation.generate(_ElevationMap, "r", _SubdivisionX, _SubdivisionY, _FactorX, _FactorY, _Elevate);
			
			_Extrude=null;
			
			_Extrude = new SkinExtrude(_Vertices, { coverall: true, recenter:true, material: _Material, bothsides:false } );
			
			_Extrude.bothsides = true;
			_Extrude.rotationX = 90;
			_Extrude.scale(1);
			_Extrude.x=-150;
			_Extrude.z=-150;
			_Extrude.y=-600;
			
			_View.scene.addChild(_Extrude);
		}
		
		private function initObjects():void
		{							
			 _ElevationMap = Cast.bitmap(elevationBitmap);
			 _Terrain = Cast.bitmap(elevationBitmap);

			_Material = new BitmapMaterial(_Terrain, {smooth: true});
 
			_Elevation = new Elevation();
					
			generateElevationMap();						
		}
			
				
		private function onMouseWheel(event:MouseEvent):void
		{			
			_Camera.distance+= -event.delta *100;
			if(_Camera.distance<50){_Camera.distance=50;}			
		}	
			
		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle = _Camera.panAngle;
			_LastTiltAngle = _Camera.tiltAngle;
			
			_LastMouseX = stage.mouseX;
			_LastMouseY = stage.mouseY;
			_Moving = true;				
		}
		
		private function onMouseUp(event:MouseEvent):void
		{
			_Moving = false;
		}
		
		private function onEnterFrame(event:Event):void
		{
			var cameraSpeed:Number = 0.5; 
			if (_Moving) {
				_Camera.panAngle = cameraSpeed*(stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle = cameraSpeed*(stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}
					
			_Camera.hover();
			_View.render();				
		}
		
		public function onSliderMove(ThisSlider:Slider):void
		{								
		}
		
		public function onSliderRelease(ThisSlider:Slider):void
		{
			switch (ThisSlider) 
			{
				case _Slider1:
					_SubdivisionX = ThisSlider.getCursorPosition();	
					_View.scene.removeChild(_Extrude);			
					generateElevationMap();						
				break;
				case _Slider2:
					_SubdivisionY =ThisSlider.getCursorPosition() ;
					_View.scene.removeChild(_Extrude);
					generateElevationMap();				
				break;	
				case _Slider3:
					_FactorX = ThisSlider.getCursorPosition();
					_View.scene.removeChild(_Extrude);
					generateElevationMap();
				break;				
				case _Slider4:
					_FactorY = ThisSlider.getCursorPosition(); 
					_View.scene.removeChild(_Extrude);
					generateElevationMap();
				break;
				case _Slider5:
					_Elevate = ThisSlider.getCursorPosition(); 
					_View.scene.removeChild(_Extrude);
					generateElevationMap();
				break;			
			}	
		}
	}
}