package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	import away3d.primitives.data.*;

	import flash.display.*;
	import flash.events.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="400")]
	public class anim7 extends Sprite implements ISlider
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		private var _Mat:WireColorMaterial;

		//objects
		private var _BezierPatch:BezierPatch;
		private var _PatchVerts:Array;
		private var _SegmentsW:Number=6;
		private var _SegmentsH:Number=6;
		private var _PatchNode:Array;
		private var _Orientation:int;
		private var _X:int=0;
		private var _Y:int=0;
		private var _Z:int=0;
		private var _XY:int=0;
		private var _YZ:int=0;
		private var _XZ:int=0;
		private var _XYZ:int=0;
		private var _YRotation:Number=0;

		// Sliders		
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Slider5:Slider;
		private var _Slider6:Slider;
		private var _Slider7:Slider;
		private var _Slider8:Slider;
		private var _Slider9:Slider;
		
		import flash.geom.*;

		public function anim7()
		{
			initEngine();
			initMat();
			initObjects();
			initSliders();
			initListeners();
		}

		public function initMat():void
		{
			_Mat=new WireColorMaterial(0xF4661B);
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 18, focus: 2000, distance: 18000});

			_View=new View3D({_Camera: _Camera, x: 320, y: 200});
			_View.scene=_Scene;

			addChild(_View);

			_Camera.lookAt(new Vector3D(0, 0, 0));
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider8=new Slider();
			_Slider8.setMinMax(1, 10);
			_Slider8.setTitle("segmentsW");
			_Slider8.create();
			_Slider8.setCursorPosition(5);

			_Slider9=new Slider();
			_Slider9.setMinMax(1, 10);
			_Slider9.setTitle("segmentsH");
			_Slider9.create();
			_Slider9.setCursorPosition(5);

			Slider.CONTROL_WIDTH=20;

			_Slider1=new Slider();
			_Slider1.setMinMax(0, 1);
			_Slider1.setTitle("BezierPatch.X");
			_Slider1.create();
			_Slider1.setCursorPosition(0);

			_Slider2=new Slider();
			_Slider2.setMinMax(0, 1);
			_Slider2.setTitle("BezierPatch.Z");
			_Slider2.create();
			_Slider2.setCursorPosition(0);

			_Slider3=new Slider();
			_Slider3.setMinMax(0, 1);
			_Slider3.setTitle("BezierPatch.XZ");
			_Slider3.create();
			_Slider3.setCursorPosition(0);

			_Slider4=new Slider();
			_Slider4.setMinMax(0, 1);
			_Slider4.setTitle("BezierPatch.XYZ");
			_Slider4.create();
			_Slider4.setCursorPosition(0);

			_Slider5=new Slider();
			_Slider5.setMinMax(0, 1);
			_Slider5.setTitle("BezierPatch.Y");
			_Slider5.create();
			_Slider5.setCursorPosition(0);

			_Slider6=new Slider();
			_Slider6.setMinMax(0, 1);
			_Slider6.setTitle("BezierPatch.XY");
			_Slider6.create();
			_Slider6.setCursorPosition(0);

			_Slider7=new Slider();
			_Slider7.setMinMax(0, 1);
			_Slider7.setTitle("BezierPatch.YZ");
			_Slider7.create();
			_Slider7.setCursorPosition(0);

		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_X=0;

					if (ThisSlider.getCursorPosition() == 1)
					{
						_X=BezierPatch.X;
					}
					break;
				case _Slider2:
					_Z=0;

					if (ThisSlider.getCursorPosition() == 1)
					{
						_Z=BezierPatch.Z;
					}
					break;
				case _Slider3:
					_XZ=0;

					if (ThisSlider.getCursorPosition() == 1)
					{
						_XZ=BezierPatch.XZ;
					}
					break;
				case _Slider4:
					_XYZ=0;

					if (ThisSlider.getCursorPosition() == 1)
					{
						_XYZ=BezierPatch.XYZ;
					}
					break;
				case _Slider5:
					_Y=0;

					if (ThisSlider.getCursorPosition() == 1)
					{
						_Y=BezierPatch.Y;
					}
					break;
				case _Slider6:
					_XY=0;

					if (ThisSlider.getCursorPosition() == 1)
					{
						_XY=BezierPatch.XY;
					}
					break;
				case _Slider7:
					_YZ=0;

					if (ThisSlider.getCursorPosition() == 1)
					{
						_YZ=BezierPatch.YZ;
					}
					break;
				case _Slider8:
					_SegmentsW=ThisSlider.getCursorPosition();

					break;
				case _Slider9:
					_SegmentsH=ThisSlider.getCursorPosition();
					break;

			}
		}

		private function initObjects():void
		{
			_PatchNode=new Array();
			_PatchNode["plane"]=new Array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);

			_PatchVerts=new Array(

				new Vertex(0, 0, 0), new Vertex(0, 40, 0), new Vertex(0, 80, 0), new Vertex(0, 120, 0), new Vertex(40, 0, 0), new Vertex(40, 40, 0), new Vertex(40, 80, 400), new Vertex(40, 120, 0), new Vertex(80, 0, 0), new Vertex(80, 40, 0), new Vertex(80, 80, 0), new Vertex(80, 120, 0), new Vertex(120, 0, 0), new Vertex(120, 40, 0), new Vertex(120, 80, 0), new Vertex(120, 120, 0));

			var PatchInfo:Array=new Array({key: "plane", orientation: BezierPatch.N | _Orientation, segmentsW: _SegmentsW, segmentsH: _SegmentsH});

			var PlaneData:PatchData=new PatchData(_PatchNode, _PatchVerts, null, PatchInfo, 1);
			_BezierPatch=new BezierPatch(PlaneData, {name: "plane", material: _Mat, bothsides: true});
			_BezierPatch.x=30;
			_BezierPatch.y=30;

			_View.scene.addChild(_BezierPatch);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_BezierPatch.rotationY+=1;
			_YRotation=_BezierPatch.rotationY;

			_Camera.hover();
			_View.render();
		}

		// override ISlider's properties
		public function onSliderMove(ThisSlider:Slider):void
		{

		}

		// override ISlider's properties
		public function onSliderRelease(ThisSlider:Slider):void
		{

			updateMeshProperties(ThisSlider);

			var _Orientation:int=BezierPatch.N | _X | _Y | _Z | _XY | _XZ | _YZ | _XYZ;

			_View.scene.removeChild(_BezierPatch);
			var PatchInfo:Array=new Array({key: "plane", orientation: _Orientation, segmentsW: _SegmentsW, segmentsH: _SegmentsH});
			var PlaneData:PatchData=new PatchData(_PatchNode, _PatchVerts, null, PatchInfo, 1);
			_BezierPatch=new BezierPatch(PlaneData, {name: "plane", material: _Mat, bothsides: true});
			_BezierPatch.x=30;
			_BezierPatch.y=30;
			_BezierPatch.rotationY=_YRotation;
			_View.scene.addChild(_BezierPatch);

		}

	}
}