package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.TextField3D;

	import flash.display.*;
	import flash.events.*;

	import wumedia.vector.VectorText;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="550", height="260")]
	public class anim3 extends Sprite implements ISlider
	{

		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		//objects
		private var _Textfield:TextField3D;

		// Sliders		
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;

		[Embed(source="assets/fonts.swf", mimeType="application/octet-stream")]
		public var FontBytes:Class;

		public function anim3()
		{
			initEngine();
			initFonts();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initFonts():void
		{
			VectorText.extractFont(new FontBytes(), null, false);
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 18, focus: 2000, distance: 18000});

			_View=new View3D({_Camera: _Camera, x: 270, y: 130});
			_View.scene=_Scene;

			addChild(_View);
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;

			_Slider1=new Slider();
			_Slider1.setMinMax(10, 50);
			_Slider1.setTitle("size");
			_Slider1.create();
			_Slider1.setCursorPosition(30);

			_Slider2=new Slider();
			_Slider2.setMinMax(1, 200);
			_Slider2.setTitle("leading");
			_Slider2.create();
			_Slider2.setCursorPosition(20);

			_Slider3=new Slider();
			_Slider3.setMinMax(0, 300);
			_Slider3.setTitle("textWidth");
			_Slider3.create();
			_Slider3.setCursorPosition(300);
		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_Textfield.size=ThisSlider.getCursorPosition();
					break;
				case _Slider2:
					_Textfield.leading=ThisSlider.getCursorPosition();
					break;
				case _Slider3:
					_Textfield.width=ThisSlider.getCursorPosition();
					break;

			}
		}

		private function initObjects():void
		{
			_Textfield=new TextField3D("Arial");
			_Textfield.text="Bonjour tout le monde."
			_Textfield.material=new ColorMaterial(0xF4661B);
			_Textfield.size=30
			_Textfield.leading=20;
			_Textfield.letterSpacing=3;
			_Textfield.width=300;
			_Textfield.align="C"
			_Textfield.x=50;

			_View.scene.addChild(_Textfield);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_Textfield.rotationY+=1;

			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}
	}
}