package
{
	import away3d.extrusions.TextExtrusion;
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.extrusions.TextExtrusion;
	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;

	import wumedia.vector.VectorText;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="550", height="260")]
	public class anim4 extends Sprite implements ISlider
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		//objects
		private var _Textfield:TextField3D;
		private var _Extrusion:TextExtrusion;

		// Sliders		
		private var _Slider1:Slider;
		private var _Slider2:Slider;

		private var _SubdivisionsXY:Number=1;
		private var _SubdivisionsZ:Number=1;
		private var _Depth:Number=20;
		private var _Bothsides:Boolean=false;

		private var _YRotation:Number=0;

		[Embed(source="assets/fonts.swf", mimeType="application/octet-stream")]
		public var FontBytes:Class;

		public function anim4()
		{
			initEngine();
			initFonts();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initFonts():void
		{
			VectorText.extractFont(new FontBytes(), null, false);
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 18, focus: 2000, distance: 18000});

			_View=new View3D({_Camera: _Camera, x: 360, y: 190});
			_View.scene=_Scene;

			addChild(_View);
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider1=new Slider();
			_Slider1.setMinMax(1, 60);
			_Slider1.setTitle("depth");
			_Slider1.create();
			_Slider1.setCursorPosition(20);

			_Slider2=new Slider();
			_Slider2.setMinMax(0, 1);
			_Slider2.setWidth(20);
			_Slider2.setTitle("bothsides");
			_Slider2.create();
			_Slider2.setCursorPosition(1);

		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_Depth=ThisSlider.getCursorPosition();
					break;
				case _Slider2:
					_Bothsides=ThisSlider.getCursorPosition() == 1;
					break;

			}
		}

		private function initObjects():void
		{
			_Textfield=new TextField3D("Arial");
			_Textfield.text="Du texte ..."
			_Textfield.material=new WireColorMaterial(0xF4661B);
			_Textfield.size=65
			_Textfield.leading=1;
			_Textfield.letterSpacing=50;
			_Textfield.width=400;
			_Textfield.align="C"
			_Textfield.x=120;

			_Extrusion=new TextExtrusion(_Textfield, {subdivisionsXY: _SubdivisionsXY, subdivisionsZ: _SubdivisionsZ, bothsides: _Bothsides, depth: _Depth});
			_Extrusion.x=-80;
			_Extrusion.y = +80;
			_View.scene.addChild(_Extrusion);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_Extrusion.rotationY+=1;
			_YRotation=_Extrusion.rotationY;
			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
			_View.scene.removeChild(_Extrusion);
			_Extrusion=new TextExtrusion(_Textfield, {subdivisionsXY: _SubdivisionsXY, subdivisionsZ: _SubdivisionsZ, bothsides: _Bothsides, depth: _Depth});
			_View.scene.addChild(_Extrusion);
			_Extrusion.rotationY=_YRotation;
			_Extrusion.x=-80;
			_Extrusion.y=+80;

		}

	}
}