package
{

	import away3d.materials.MovieMaterial;
	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.BitmapMaterial;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="350")]
	public class anim6 extends Sprite
	{
		[Embed(source="/assets/damier.jpg")]
		private var _Texture:Class;

		//engine variables
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		// camera
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;

		//objects
		private var _MovieMaterial:MovieMaterial;

		[Embed(source="/assets/cocci.swf")]
		private var _TextureAnim:Class;

		public function anim6()
		{
			initEngine();
			initMaterial();
			initObjects();
			initListeners();
		}

		private function initMaterial():void
		{
			_MovieMaterial=new MovieMaterial(new _TextureAnim(), {smooth: true, precision: 5});
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 700});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .5, y: stage.stageHeight * .5});
			addChild(_View);

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);
		}

		private function initObjects():void
		{
			var plane:Cube=new Cube();
			plane.material=_MovieMaterial;
			plane.scale(2.5);
			_View.scene.addChild(plane);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function onMouseWheel(event:MouseEvent):void
		{
			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}
		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;

			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
			stage.removeEventListener(MouseEvent.MOUSE_UP, onMouseUp);
		}

		private function onEnterFrame(event:Event):void
		{
			if (_Moving)
			{
				_Camera.panAngle=0.5 * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=0.5 * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}

			_Camera.hover();
			_View.render();
		}

	}
}