package
{

	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.lights.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;

	import objects.Mur;

	[SWF(backgroundColor="#000000", frameRate="30", quality="LOW", width="570", height="350")]
	public class anim4 extends Sprite implements ISlider, ICheckBox
	{

		[Embed(source="/assets/mur_diffuse.jpg")]
		private var _Texture_Mur_Diffuse:Class;

		[Embed(source="assets/mur_diffuse_unis.jpg")]
		private var _Texture_Mur_Diffuse_Unis:Class;

		[Embed(source="/assets/mur_normal.jpg")]
		private var _Texture_Mur_Normal:Class;

		//engine variables
		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;
		private var _Light:DirectionalLight3D;
		private var _Dot3BitmapMaterial:Dot3BitmapMaterial;
		private var _Dot3BitmapMaterialNoDiffuse:Dot3BitmapMaterial;

		//objects
		private var _Sphere:Sphere;
		private var _Mur:Mur;

		// Sliders		
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Slider5:Slider;
		private var _Slider6:Slider;

		// Checkboxes
		private var _Checkbox1:CheckBox;

		private var _Shininess:Number=20;
		private var _LightAmbient:Number=0.1;
		private var _LightDiffuse:Number=0.4;
		private var _LightSpecular:Number=0.1;
		private var _LightBrightness:Number=1;

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.TEXT_COLOR=0x888888;
			Slider.LINE_COLOR=0x888888;
			Slider.CURSOR_COLOR=0xaaaaaa;

			_Slider3=new Slider();
			_Slider3.setMinMax(0, 1, 1);
			_Slider3.setTitle("ambient");
			_Slider3.create();
			_Slider3.setCursorPosition(_LightAmbient);

			_Slider5=new Slider();
			_Slider5.setMinMax(0, 0.5, 1);
			_Slider5.setTitle("specular");
			_Slider5.create();
			_Slider5.setCursorPosition(_LightSpecular);

			_Slider6=new Slider();
			_Slider6.setMinMax(0, 10, 1);
			_Slider6.setTitle("brightness");
			_Slider6.create();
			_Slider6.setCursorPosition(_LightBrightness);

			Slider.Y_POS=200;

			_Slider2=new Slider();
			_Slider2.setMinMax(0, 50);
			_Slider2.setTitle("shininess");
			_Slider2.create();
			_Slider2.setCursorPosition(_Shininess);

			CheckBox.X_POS=530;
			CheckBox.Y_POS=20;
			CheckBox.Y_OFFSET=20;
			CheckBox.CALLBACK_INTERFACE=this;
			CheckBox.FONT_SIZE=12;
			CheckBox.SQUARE_COLOR=0x888888;
			CheckBox.TICK_COLOR=0xaaaaaa;
			CheckBox.TITLE_COLOR=0x888888;

			_Checkbox1=new CheckBox(this, false);
			_Checkbox1.setTitle("diffuse");
			_Checkbox1.setOrientation(CheckBox.RIGHT);
			_Checkbox1.create();
			_Checkbox1.setState(true);

		}

		public function anim4()
		{
			initEngine();
			initMaterial();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 700});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .5, y: stage.stageHeight * .5});
			addChild(_View);
			_View.forceUpdate=true;
			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);
		}

		private function initMaterial():void
		{
			var diffuseBitmap:Bitmap=new _Texture_Mur_Diffuse() as Bitmap;
			var normalBitmap:Bitmap=new _Texture_Mur_Normal() as Bitmap;
			var ct:ColorTransform=new ColorTransform(-1, 1, 1, 1, 255, 0, 0, 0);
			normalBitmap.bitmapData.colorTransform(new Rectangle(0, 0, normalBitmap.width, normalBitmap.height), ct);

			_Dot3BitmapMaterial=new Dot3BitmapMaterial(Cast.bitmap(diffuseBitmap), Cast.bitmap(normalBitmap), {smooth: true, precision: 1, shininess: 50, specular: 0xffffff});
			_Dot3BitmapMaterial.repeat=false;

			var diffuseBitmapUnis:Bitmap=new _Texture_Mur_Diffuse_Unis() as Bitmap;
			_Dot3BitmapMaterialNoDiffuse=new Dot3BitmapMaterial(Cast.bitmap(diffuseBitmapUnis), Cast.bitmap(normalBitmap), {smooth: true, precision: 1, shininess: 50, specular: 0xffffff});
			_Dot3BitmapMaterialNoDiffuse.repeat=false;

		}

		private function initObjects():void
		{

			_Light=new DirectionalLight3D({color: 0xFFFFFF, ambient: _LightAmbient, diffuse: _LightDiffuse, specular: _LightSpecular, brightness: _LightBrightness});
			_Light.direction=new Vector3D(150, 0, 200)
			_View.scene.addLight(_Light);

			_Sphere=new Sphere();
			_Sphere.radius=10;
			_Sphere.x=-150;
			_Sphere.z=-200;

			_Sphere.material=new ColorMaterial(0xffeedd);
			_View.scene.addChild(_Sphere);

			_Mur=new Mur();
			_Mur.rotationX=90;
			_Mur.scale(5);

			_Mur.material=_Dot3BitmapMaterial;

			_View.scene.addChild(_Mur);

		}

		private function onMouseWheel(event:MouseEvent):void
		{

			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}

		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;

		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{
			if (_Moving)
			{
				_Camera.panAngle=0.5 * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=0.5 * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}
			_Camera.panAngle=_Camera.panAngle + 0.5;
			_Camera.hover();
			_View.forceUpdate=true;
			_View.render();
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider3:
					_Dot3BitmapMaterial.smooth=(ThisSlider.getCursorPosition() == 1);
					break;
			}
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider2:
					_Shininess=ThisSlider.getCursorPosition();
					_Dot3BitmapMaterial.shininess=_Shininess
					break;
				case _Slider3:
					_LightAmbient=ThisSlider.getCursorPosition();
					_Light.ambient=_LightAmbient;
					break;
				case _Slider4:
					_LightDiffuse=ThisSlider.getCursorPosition();
					_Light.diffuse=_LightDiffuse
					break;
				case _Slider5:
					_LightSpecular=ThisSlider.getCursorPosition();
					_Light.specular=_LightSpecular
					break;
				case _Slider6:
					_LightBrightness=ThisSlider.getCursorPosition();
					_Light.brightness=_LightBrightness
					break;
			}
		}

		public function onCheckBoxStateChange(ThisCheckBox:CheckBox):void
		{
			if (_Checkbox1.getState() == false)
			{
				_Mur.material=_Dot3BitmapMaterialNoDiffuse;
			}
			else
			{
				_Mur.material=_Dot3BitmapMaterial;
			}
		}
	}
}