package
{

	import SGComponents.*;
	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.lights.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import objects.Mur;

	[SWF(backgroundColor="#000000", frameRate="30", quality="LOW", width="570", height="350")]
	public class anim5 extends Sprite implements ISlider, ICheckBox
	{

		[Embed(source="/assets/mur_diffuse.jpg")]
		private var _Texture_Mur_Diffuse:Class;

		[Embed(source="/assets/mur_diffuse_unis.jpg")]
		private var _Texture_Mur_Diffuse_Unis:Class;

		[Embed(source="/assets/mur_normal.jpg")]
		private var _Texture_Mur_Normal:Class;

		private var _Camera:HoverCamera3D;
		private var _View:View3D;
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;
		private var _DiffusePBMaterialWall:DiffusePBMaterial;
		private var _DiffusePBMaterialUniform:DiffusePBMaterial;
		private var _pointLight:PointLight3D;
		private var _Mur:Mur;

		//objects
		private var _Sphere:Sphere;

		// Sliders		
		private var _Slider1:Slider;
		private var _Slider2:Slider;

		// Checkboxes
		private var _Checkbox1:CheckBox;

		private var _Rot:Number=0;

		//Light
		private var _LightAmbient:Number=0.1;
		private var _LightDiffuse:Number=0.4;
		private var _LightSpecular:Number=0.1;
		private var _LightBrightness:Number=1;
		private var _LightRadius:Number=50;
		private var _LightFalloff:Number=1000;

		// Texture
		private var _DiffuseBitmapWall:Bitmap;
		private var _DiffuseBitmapUniform:Bitmap;
		private var _NormalBitmap:Bitmap;

		public function anim5()
		{
			initEngine();
			initObjects();
			initMaterials();
			initSliders();
			initListeners();
			createObjects();
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.TEXT_COLOR=0x888888;
			Slider.LINE_COLOR=0x888888;
			Slider.CURSOR_COLOR=0xaaaaaa;

			_Slider1=new Slider();
			_Slider1.setMinMax(0, 5, 1);
			_Slider1.setTitle("diffuse");
			_Slider1.create();
			_Slider1.setCursorPosition(_LightDiffuse);

			_Slider2=new Slider();
			_Slider2.setMinMax(0, 1, 1);
			_Slider2.setTitle("brightness");
			_Slider2.create();
			_Slider2.setCursorPosition(_LightBrightness);


			CheckBox.X_POS=530;
			CheckBox.Y_POS=20;
			CheckBox.Y_OFFSET=20;
			CheckBox.CALLBACK_INTERFACE=this;
			CheckBox.FONT_SIZE=12;
			CheckBox.SQUARE_COLOR=0x888888;
			CheckBox.TICK_COLOR=0xaaaaaa;
			CheckBox.TITLE_COLOR=0x888888;

			_Checkbox1=new CheckBox(this, false);
			_Checkbox1.setTitle("diffuse");
			_Checkbox1.setOrientation(CheckBox.RIGHT);
			_Checkbox1.create();
			_Checkbox1.setState(true);

		}

		private function initMaterials():void
		{
			_DiffuseBitmapWall=new _Texture_Mur_Diffuse() as Bitmap;
			_DiffuseBitmapUniform=new _Texture_Mur_Diffuse_Unis() as Bitmap;
			_NormalBitmap=new _Texture_Mur_Normal() as Bitmap;

			var ct:ColorTransform=new ColorTransform(-1, 1, 1, 1, 255, 0, 0, 0);
			_NormalBitmap.bitmapData.colorTransform(new Rectangle(0, 0, _NormalBitmap.width, _NormalBitmap.height), ct);

			_DiffusePBMaterialWall=new DiffusePBMaterial(Cast.bitmap(_DiffuseBitmapWall), Cast.bitmap(_NormalBitmap), _Mur, null);
			_DiffusePBMaterialUniform=new DiffusePBMaterial(Cast.bitmap(_DiffuseBitmapUniform), Cast.bitmap(_NormalBitmap), _Mur, null);

		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 700});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .6, y: stage.stageHeight * .5});

			addChild(_View);

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function initObjects():void
		{
			_pointLight=new PointLight3D();
			_pointLight.color=0xffeedd;
			_pointLight.brightness=_LightBrightness;
			_pointLight.ambient=_LightAmbient;
			_pointLight.diffuse=_LightDiffuse;
			_pointLight.specular=_LightSpecular;
			_pointLight.radius=_LightRadius;
			_pointLight.x=-150;
			_pointLight.z=-200;
			_pointLight.y=0;
			_View.scene.addLight(_pointLight);

			_Sphere=new Sphere();
			_Sphere.radius=10;
			_Sphere.x=250;
			_Sphere.z=-10;
			_Sphere.y=0;

			_Mur=new Mur();
			_Mur.rotationX=90;
			_Mur.scale(5);

		}

		private function createObjects():void
		{
			_Sphere.material=new ColorMaterial(0xffeedd);
			_View.scene.addChild(_Sphere);

			_Mur.material=_DiffusePBMaterialWall;
			_View.scene.addChild(_Mur);
		}

		private function onMouseWheel(event:MouseEvent):void
		{
			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}
		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{
			var cameraSpeed:Number=0.5;

			if (_Moving)
			{
				_Camera.panAngle=cameraSpeed * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=cameraSpeed * (stage.mouseY - _LastMouseY) + _LastTiltAngle;

			}
			_Rot++;
			_Sphere.x=_pointLight.x=-350 * Math.cos(_Rot / 20);
			_Sphere.z=_pointLight.z=-350 * Math.sin(_Rot / 20);
			_Camera.hover();
			_View.render();
		}

		// override ISlider's properties
		public function onSliderRelease(ThisSlider:Slider):void
		{
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{

				case _Slider1:
					_LightDiffuse=ThisSlider.getCursorPosition();
					_pointLight.diffuse=_LightDiffuse;
					break;
				case _Slider2:
					_LightBrightness=ThisSlider.getCursorPosition();
					_pointLight.brightness=_LightBrightness;
					break;
			}

		}

		public function onCheckBoxStateChange(ThisCheckBox:CheckBox):void
		{
			if (_Checkbox1.getState() == false)
			{
				_Mur.material=_DiffusePBMaterialUniform;
			}

			if (_Checkbox1.getState() == true)
			{
				_Mur.material=_DiffusePBMaterialWall;
			}

		}

	}
}