package
{

	import SGComponents.*;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.lights.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.materials.utils.TangentToObjectMapper;
	import away3d.primitives.*;
	import away3d.primitives.utils.CubeFaces;

	import flash.display.*;
	import flash.events.*;

	[SWF(backgroundColor="#000000", frameRate="30", quality="LOW", width="570", height="280")]
	public class anim6 extends Sprite implements ISlider, ICheckBox
	{

		[Embed(source="/assets/no_normal.jpg")]
		private var _Texture_Normal:Class;

		[Embed(source="/assets/damier.jpg")]
		private var _Texture:Class;

		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		// camera
		private var _LastPanAngle:Number;
		private var _LastTiltAngle:Number;
		private var _LastMouseX:Number;
		private var _LastMouseY:Number;
		private var _Moving:Boolean;

		//objects
		private var _Cube:Cube;
		private var _Sphere:Sphere;
		private var _Cylinder:Cylinder;
		private var _Plane:Plane;
		private var _Mesh:Mesh;

		// Sliders		
		private var _Slider1:Slider;

		//checkboxes
		private var _Checkbox1:CheckBox;
		private var _Checkbox2:CheckBox;
		private var _Checkbox3:CheckBox;
		private var _Checkbox4:CheckBox;

		//materials
		private var _CubicEnvMapPBMaterial:CubicEnvMapPBMaterial;
		private var _EnvMapAlpha:Number=0.5;

		//Texture
		private var _TextureBitmap:Bitmap;
		private var _NormalBitmap:Bitmap;

		//skybox
		private var _Skybox:Skybox;
		[Embed(source="assets/skybox/XN.jpg")]
		private var _left:Class;
		[Embed(source="assets/skybox/XP.jpg")]
		private var _right:Class;
		[Embed(source="assets/skybox/YP.jpg")]
		private var _top:Class;
		[Embed(source="assets/skybox/YN.jpg")]
		private var _bottom:Class;
		[Embed(source="assets/skybox/ZP.jpg")]
		private var _back:Class;
		[Embed(source="assets/skybox/ZN.jpg")]
		private var _front:Class;

		private var _Faces:Array=[];

		public function anim6()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initEngine():void
		{
			_Camera=new HoverCamera3D({zoom: 6, focus: 100, distance: 700});

			_View=new View3D({camera: _Camera, x: stage.stageWidth * .5, y: stage.stageHeight * .5});
			addChild(_View);

			_Camera.panAngle=-120;
			_Camera.tiltAngle=9.5;
			_Camera.minTiltAngle=-90;
			_Camera.hover(true);

			_Faces[CubeFaces.LEFT]=new _left().bitmapData;
			_Faces[CubeFaces.RIGHT]=new _right().bitmapData;
			_Faces[CubeFaces.FRONT]=new _front().bitmapData;
			_Faces[CubeFaces.BACK]=new _back().bitmapData;
			_Faces[CubeFaces.TOP]=new _top().bitmapData;
			_Faces[CubeFaces.BOTTOM]=new _bottom().bitmapData;

			_TextureBitmap=new _Texture() as Bitmap;
			_NormalBitmap=new _Texture_Normal() as Bitmap;
		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;
			Slider.TEXT_COLOR=0xbbbbbb;
			Slider.LINE_COLOR=0xbbbbbb;
			Slider.CURSOR_COLOR=0xdddddd;
			_Slider1=new Slider();
			_Slider1.setMinMax(0, 1, 1);
			_Slider1.setTitle("envMapAlpha");
			_Slider1.create();
			_Slider1.setCursorPosition(_EnvMapAlpha);

			CheckBox.X_POS=530;
			CheckBox.Y_POS=20;
			CheckBox.Y_OFFSET=20;
			CheckBox.CALLBACK_INTERFACE=this;
			CheckBox.FONT_SIZE=12;
			CheckBox.SQUARE_COLOR=0xbbbbbb;
			CheckBox.TICK_COLOR=0xaaaaaa;
			CheckBox.TITLE_COLOR=0xbbbbbb;

			_Checkbox1=new CheckBox(this, true);
			_Checkbox1.setTitle("cube");
			_Checkbox1.setOrientation(CheckBox.RIGHT);
			_Checkbox1.create();
			_Checkbox1.setState(true);

			_Checkbox2=new CheckBox(this, true);
			_Checkbox2.setTitle("plane");
			_Checkbox2.setOrientation(CheckBox.RIGHT);
			_Checkbox2.create();
			_Checkbox2.setState(false);

			_Checkbox3=new CheckBox(this, true);
			_Checkbox3.setTitle("sphere");
			_Checkbox3.setOrientation(CheckBox.RIGHT);
			_Checkbox3.create();
			_Checkbox3.setState(false);

		}

		private function createCube():Mesh
		{
			_Cube=new Cube();
			_Cube.width=160;
			_Cube.height=160;
			_Cube.depth=160;
			_Cube.segmentsH=1;
			_Cube.segmentsW=1;
			_Cube.mappingType=CubeMappingType.MAP6;

			var NormalBitmapdata:BitmapData=TangentToObjectMapper.transform(_NormalBitmap.bitmapData, _Cube, false);
			_CubicEnvMapPBMaterial=new CubicEnvMapPBMaterial(NormalBitmapdata, NormalBitmapdata, _Faces, _Cube, {smooth: false, envMapAlpha: _EnvMapAlpha});
			_Cube.material=_CubicEnvMapPBMaterial;

			return _Cube as Mesh;
		}

		private function createCylinder():Mesh
		{
			_Cylinder=new Cylinder();
			_Cylinder.radius=100;
			_Cylinder.height=170;
			_Cylinder.segmentsH=15;
			_Cylinder.segmentsW=15;

			var NormalBitmapdata:BitmapData=TangentToObjectMapper.transform(_NormalBitmap.bitmapData, _Cylinder, true);
			_CubicEnvMapPBMaterial=new CubicEnvMapPBMaterial(NormalBitmapdata, NormalBitmapdata, _Faces, _Cylinder, {smooth: false, envMapAlpha: _EnvMapAlpha});
			_Cylinder.material=_CubicEnvMapPBMaterial;

			return _Cylinder as Mesh;
		}

		private function createPlane():Mesh
		{
			_Plane=new Plane();
			_Plane.width=170;
			_Plane.height=170;
			_Plane.segmentsH=1;
			_Plane.segmentsW=1;
			_Plane.rotationX=-90;
			_Plane.bothsides=true;

			var NormalBitmapdata:BitmapData=TangentToObjectMapper.transform(_NormalBitmap.bitmapData, _Plane, true);
			_CubicEnvMapPBMaterial=new CubicEnvMapPBMaterial(NormalBitmapdata, NormalBitmapdata, _Faces, _Plane, {smooth: false, envMapAlpha: _EnvMapAlpha});
			_Plane.material=_CubicEnvMapPBMaterial;

			return _Plane as Mesh;
		}

		private function createSphere():Mesh
		{
			_Sphere=new Sphere();
			_Sphere.radius=100;
			_Sphere.segmentsH=10;
			_Sphere.segmentsW=10;

			var NormalBitmapdata:BitmapData=TangentToObjectMapper.transform(_NormalBitmap.bitmapData, _Sphere, true);
			_CubicEnvMapPBMaterial=new CubicEnvMapPBMaterial(NormalBitmapdata, NormalBitmapdata, _Faces, _Sphere, {smooth: false, envMapAlpha: _EnvMapAlpha});
			_Sphere.material=_CubicEnvMapPBMaterial;

			return _Sphere as Mesh;
		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_EnvMapAlpha=ThisSlider.getCursorPosition();
					_CubicEnvMapPBMaterial.envMapAlpha=_EnvMapAlpha;
					break;
			}
		}

		private function initObjects():void
		{

			_Skybox=new Skybox(new BitmapMaterial(Cast.bitmap(_back)), new BitmapMaterial(Cast.bitmap(_left)), new BitmapMaterial(Cast.bitmap(_front)), new BitmapMaterial(Cast.bitmap(_right)), new BitmapMaterial(Cast.bitmap(_top)), new BitmapMaterial(Cast.bitmap(_bottom)));
			_Skybox.scale(0.008);

			_View.scene.addChild(_Skybox);

			_Mesh=this.createCube();
			_View.scene.addChild(_Mesh);

		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			stage.addEventListener(MouseEvent.MOUSE_WHEEL, onMouseWheel);
		}

		private function onMouseWheel(event:MouseEvent):void
		{

			_Camera.distance+=-event.delta * 10;

			if (_Camera.distance < 50)
			{
				_Camera.distance=50;
			}

		}

		private function onMouseDown(event:MouseEvent):void
		{
			_LastPanAngle=_Camera.panAngle;
			_LastTiltAngle=_Camera.tiltAngle;

			_LastMouseX=stage.mouseX;
			_LastMouseY=stage.mouseY;
			_Moving=true;

		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
		}

		private function onEnterFrame(event:Event):void
		{
			var cameraSpeed:Number=0.5;

			if (_Moving)
			{
				_Camera.panAngle=cameraSpeed * (stage.mouseX - _LastMouseX) + _LastPanAngle;
				_Camera.tiltAngle=cameraSpeed * (stage.mouseY - _LastMouseY) + _LastTiltAngle;
			}

			_Camera.hover();
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
		}

		public function onCheckBoxStateChange(ThisCheckBox:CheckBox):void
		{
			if (_Mesh)
			{
				_View.scene.removeChild(_Mesh);
				_Mesh.material=null;
				_Mesh=null;
			}

			_Cube=null;
			_Sphere=null;
			_Cylinder=null;
			_Plane=null;

			switch (ThisCheckBox)
			{
				case _Checkbox1: //cube					
					_Mesh=this.createCube();
					_View.scene.addChild(_Mesh);
					break;
				case _Checkbox2: //plane
					_Mesh=this.createPlane();
					_View.scene.addChild(_Mesh);
					break;
				case _Checkbox3: //sphere
					_Mesh=this.createSphere();
					_View.scene.addChild(_Mesh);

					break;
				case _Checkbox4: //cylindre
					_Mesh=this.createCylinder();
					_View.scene.addChild(_Mesh);
					break;

			}
		}
	}
}