﻿
package
{
	import away3d.animators.Animator;
	import away3d.loaders.utils.AnimationLibrary;
	import away3d.animators.data.*;
	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.utils.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.test.Button;

	import flash.display.*;
	import flash.events.*;

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="350")]

	public class anim1 extends Sprite
	{

		[Embed(source="assets/etoile.md2", mimeType="application/octet-stream")]
		private var _EtoileMesh:Class;

		[Embed(source="assets/etoile_texture.jpg")]
		private var _EtoileTexture:Class;

		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		private var material:BitmapMaterial;

		private var _Md2:Md2;
		private var _Model:Mesh;

		private var _HautButton:Button;
		private var _BasButton:Button;
		private var _GaucheButton:Button;
		private var _DroiteButton:Button;

		private var _Moving:Boolean=false;
		private var lastPanAngle:Number;
		private var lastTiltAngle:Number;
		private var lastMouseX:Number;
		private var lastMouseY:Number;

		public function anim1()
		{
			initEngine();
			initObjects();
			initButtons();
			initListeners();
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D();

			_Camera.panAngle=45;
			_Camera.tiltAngle=20;
			_Camera.hover(true);

			_View=new View3D();
			_View.scene=_Scene;
			_View.camera=_Camera;
			_View.x=stage.stageWidth / 2;
			_View.y=stage.stageHeight / 2;

			_View.addSourceURL("srcview/index.html");
			addChild(_View);
		}

		private function initObjects():void
		{
			_Md2=new Md2();
			_Md2.fps=7;

			_Model=_Md2.parseGeometry(_EtoileMesh) as Mesh;
			_Model.material=new BitmapMaterial(Cast.bitmap(_EtoileTexture));

			_Model.scale(0.35);
			_Scene.addChild(_Model);
		}

		private function initButtons():void
		{
			_HautButton=new Button("Haut", 65);
			_HautButton.x=480;
			_HautButton.y=20;
			addChild(_HautButton);
			_BasButton=new Button("Bas", 65);
			_BasButton.x=480;
			_BasButton.y=50;
			addChild(_BasButton);
			_GaucheButton=new Button("Gauche", 65);
			_GaucheButton.x=480;
			_GaucheButton.y=80;
			addChild(_GaucheButton);
			_DroiteButton=new Button("Droite", 65);
			_DroiteButton.x=480;
			_DroiteButton.y=110;
			addChild(_DroiteButton);
		}

		private function initListeners():void
		{
			addEventListener(MouseEvent.CLICK, onButtonClick);
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
		}

		private function onButtonClick(event:Event):void
		{
			var button:Button=event.target as Button;

			switch (button)
			{
				case _HautButton:

					_Model.animationLibrary.getAnimation("haut_").animator.play();
					break;
				case _BasButton:
					_Model.animationLibrary.getAnimation("bas_").animator.play();
					break;
				case _GaucheButton:
					_Model.animationLibrary.getAnimation("gauche_").animator.play();
					break;
				case _DroiteButton:
					_Model.animationLibrary.getAnimation("droite_").animator.play();
					break;
			}
		}

		private function onEnterFrame(event:Event):void
		{

			if (_Moving)
			{
				_Camera.panAngle=0.3 * (stage.mouseX - lastMouseX) + lastPanAngle;
				_Camera.tiltAngle=0.3 * (stage.mouseY - lastMouseY) + lastTiltAngle;
			}

			_Camera.hover();
			_View.render();
		}

		private function onMouseDown(event:MouseEvent):void
		{
			lastPanAngle=_Camera.panAngle;
			lastTiltAngle=_Camera.tiltAngle;
			lastMouseX=stage.mouseX;
			lastMouseY=stage.mouseY;
			_Moving=true;
			stage.addEventListener(Event.MOUSE_LEAVE, onStageMouseLeave);
		}

		private function onMouseUp(event:MouseEvent):void
		{
			_Moving=false;
			stage.removeEventListener(Event.MOUSE_LEAVE, onStageMouseLeave);
		}

		private function onStageMouseLeave(event:Event):void
		{
			_Moving=false;
			stage.removeEventListener(Event.MOUSE_LEAVE, onStageMouseLeave);
		}
	}
}