
package SGComponents
{
	import flash.display.*;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class Button
	{
		
		private var _IButton:IButton;
		private var _ButtonContainer:DisplayObjectContainer;
		private var _Width:Number;
		private var _Height:Number;
		private var _X:Number;
		private var _Y:Number;
		private var _Text:String;
		private var _Button:Sprite;
		private var _TextArea:TextField;
		private var _TextFormat:TextFormat;
		
		public function setDimenstion(width:Number, height:Number):void
		{
			_Width = width;
			_Height = height;
		}
		
		public function setPosition(x:Number, y:Number):void
		{
			_X = x;
			_Y = y;
		}
		
		public function setText(text:String):void
		{
			_Text = text;
		}
		
		private function createText():void
		{
			_TextFormat = new TextFormat();
			_TextFormat.font = "Verdana";
            _TextFormat.color = 0xeeeeee;
            _TextFormat.size = 12;
         	
			_TextArea = new TextField();
        
        	_TextArea.height = 30;
        	_TextArea.selectable=false;
			_TextArea.defaultTextFormat=_TextFormat;
			_TextArea.autoSize = "left";		
			_TextArea.text=_Text;
			
			
			_Button.addChild(_TextArea);
			
			_TextArea.x = (_Width - _TextArea.width)/2;
			//_TextArea.x =20;
		}
		
		private function createGradient():void
		{
			var type:String = GradientType.LINEAR;
			var colors:Array = [0xaaaaaa, 0x222222];
			var alphas:Array = [1, 1];
			var ratios:Array = [0, 255];
			var spreadMethod:String = SpreadMethod.PAD;
			var interp:String = InterpolationMethod.LINEAR_RGB;
			var focalPtRatio:Number = 0;

			var matrix:Matrix = new Matrix();
			var boxWidth:Number = 50;
			var boxHeight:Number = 20;
			var boxRotation:Number = Math.PI/2; // 90˚
			var tx:Number = 25;
			var ty:Number = 0;
			
			
			
			matrix.createGradientBox(_Width, _Height/2, boxRotation, tx, ty);

			var square:Shape = new Shape;
			square.graphics.beginGradientFill(type, 
                            colors,
                            alphas,
                            ratios, 
                            matrix, 
                            spreadMethod, 
                            interp, 
                            focalPtRatio);
			square.graphics.drawRect(0,0, _Width, _Height);
			
			_Button.addChild(square);
				
			

			
		}
		
		
		public function create():void
		{
			_Button = new Sprite();
			
			createGradient();
			
			createText();
			
			_Button.x = _X;
			_Button.y = _Y;
			
			_ButtonContainer.addChild(_Button);
			_ButtonContainer.addEventListener(MouseEvent.CLICK, onButtonClick);
		
		}
		
		private function onButtonClick(event:MouseEvent):void
		{
			_IButton.onButtonClick(this);
		}
		
		public function Button(buttonContainer:DisplayObjectContainer, iButton :IButton)
		{
			
			_ButtonContainer = buttonContainer;
			_IButton = iButton;
		}

	
	

	}
}