package SGComponents
{
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class CheckBox
	{
		
		static public const LEFT:uint = 1;
		static public const RIGHT:uint = 2;	
		
		static public var CHECKBOX_ARRAY:Array=null;
		
		static public  var CALLBACK_INTERFACE:ICheckBox; 
		static public var WIDTH:Number = 12;
		static public var X_POS:Number = 20;
		static public var Y_OFFSET:Number = 30;
		static public var X_OFFSET:Number = 0;
		static public var Y_POS:Number =40;	
		static public var TICK_COLOR:uint=0x555555;
		static public var SQUARE_COLOR:uint = 0x999999;
		static public var TITLE_COLOR:uint=0x666666;
		static public var FONT_SIZE:Number = 12;
		static public var LINE_WIDTH:Number = 2;
		static public var SQUARE_WIDTH:Number = 1;
		static public var ORIENTATION:uint = LEFT;
		
		private var _Width:Number=WIDTH;
		private var _XPos:Number;
		private var _YPos:Number;
		private var _ClickableArea:Sprite;
		private var _Control:Sprite;
		private var _Tick:Sprite;
		private var _Container:DisplayObjectContainer ;	
		private var _TickColor:uint=TICK_COLOR;
		private var _SquareColor:uint = SQUARE_COLOR;
		private var _TitleColor:uint = TITLE_COLOR;
		private var _Title:String;
		private var _TitleArea:TextField;
		private var _TitleFormat:TextFormat;
		private var _FontSize:Number=FONT_SIZE;
		private var _LineWidth:Number=LINE_WIDTH;
		private var _SquareWidth:Number=SQUARE_WIDTH;
		private var _Orientation:uint=ORIENTATION;
		private var _Exclusive:Boolean=false;
		
		private var _ICheckBox:ICheckBox=CALLBACK_INTERFACE;
		
		public function CheckBox(container:DisplayObjectContainer,exclusive:Boolean=false)
		{
			_Exclusive = exclusive;
			
			if(_Exclusive)
			{
				if(!CHECKBOX_ARRAY){CHECKBOX_ARRAY = new Array();}			
				CHECKBOX_ARRAY.push(this);
			}
			
			_Container=container;	
			
		}
		
		public function setInterface(iCheckBox:ICheckBox=null):void
		{
			_ICheckBox =iCheckBox;
		}
		

		public function setState (state:Boolean):void
		{
			_Tick.visible=state;			
		}
		
		public function getState ():Boolean
		{
			return (_Tick.visible);			
		}

		public function create ():void
		{			
			if(!_XPos) {_XPos = X_POS;X_POS = _XPos + X_OFFSET;}			
			if(!_YPos) {_YPos = Y_POS ;Y_POS = _YPos + Y_OFFSET;}
			if(!_Orientation) {_Orientation = ORIENTATION ;}
			
			CreateClickableArea();
			createSquare();
			createTick();
			CreateTitle();
			
		}
		
		public function CreateClickableArea():void
		{
			_ClickableArea= new Sprite();
			_ClickableArea.graphics.beginFill(0x000000,0);		
			_ClickableArea.graphics.moveTo(_XPos-_Width, _YPos-_Width/2);
			_ClickableArea.graphics.lineTo(_XPos-_Width, _YPos+_Width+_Width/2);
			_ClickableArea.graphics.lineTo(_XPos+_Width+_Width,_YPos+ _Width+_Width/2);
			_ClickableArea.graphics.lineTo(_XPos+_Width+_Width,_YPos-_Width/2);
			_ClickableArea.graphics.lineTo(_XPos-_Width, _YPos-_Width/2);
			
			_Container.addChild(_ClickableArea);
			
			_ClickableArea.addEventListener(MouseEvent.CLICK,onMouseClick);
		}
		
		public function setOrientation(orientation:uint):void
		{
			_Orientation=orientation;
		}
		
		public function setTitle(tite:String):void
		{
			_Title=tite;
		}
		
		
		private function createSquare():void
		{			
			
			_Control= new Sprite();
			_Control.graphics.beginFill(0x000000,0);
			_Control.graphics.lineStyle(_SquareWidth, _SquareColor);	
			_Control.graphics.moveTo(_XPos, _YPos);
			_Control.graphics.lineTo(_XPos, _YPos+_Width);
			_Control.graphics.lineTo(_XPos+_Width,_YPos+ _Width);
			_Control.graphics.lineTo(_XPos+_Width,_YPos);
			_Control.graphics.lineTo(_XPos, _YPos);
						
			_ClickableArea.addChild(_Control);

		}
		
		private function onMouseClick(event:MouseEvent):void
		{
			
			if((_Tick.visible==true)&&(_Exclusive)){return;}
			
			if( _Tick.visible==true) {
				_Tick.visible=false;
			}
			else{
				_Tick.visible=true;
			}
			if(_Exclusive)
			{
				for each (var Checkbox_Object:CheckBox in CHECKBOX_ARRAY)
				{
					if(Checkbox_Object!=this){Checkbox_Object.setState(false);}
				}
			}
			if(_ICheckBox) {_ICheckBox.onCheckBoxStateChange(this);}
			
		}
		
			private function CreateTitle():void
		{	
			_TitleFormat = new TextFormat();
			_TitleFormat.font = "Verdana";
            _TitleFormat.color = _TitleColor;
            _TitleFormat.size = _FontSize;
         	
			_TitleArea = new TextField();
        
        	_TitleArea.height = _FontSize;
        	_TitleArea.selectable=false;
			_TitleArea.defaultTextFormat=_TitleFormat;
					
			_TitleArea.text=_Title;
			
			_ClickableArea.addChild(_TitleArea);
			//_TitleArea.x = _XPos-_TitleArea.width-20;
        		
        		if(_Orientation==LEFT)
        		{
        			_TitleArea.autoSize = "left";
        			_TitleArea.x = _XPos+_Width+_Width;
        		}
        		if(_Orientation==RIGHT)
        		{
        			_TitleArea.autoSize = "right";
        			_TitleArea.x = _XPos-_Width-_TitleArea.textWidth;
        		}
        		
        	_TitleArea.y = _YPos-_TitleArea.textHeight+_Width+_SquareWidth;
        	
        
		}
		
		public function setWidth(Width:Number):void
		{
			_Width=Width;
		}
		
		public function setPosition(xPos:Number,yPos:Number):void
		{
			_XPos=xPos;
			_YPos=yPos;
		}
		
		public function setColors(tickColor:uint,controlColor:uint, backgroundolor:uint):void
		{
			
		}
		
		private function createTick():void
		{
			_Tick= new Sprite();
			_Tick.graphics.lineStyle(_LineWidth, _TickColor);
			_Tick.graphics.moveTo(_XPos+_Width/5, _YPos+_Width/5);
			_Tick.graphics.lineTo(_XPos+ _Width/2, _YPos + 0.8*_Width);
			_Tick.graphics.lineTo(_XPos + _Width,_YPos-_Width/4);
				_Tick.visible =false;
						
			_ClickableArea.addChild(_Tick);
					
		}

	}
}