package SGComponents
{
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class Slider
	{
		
		static public var CURSOR_WIDTH:Number = 5;
		static public var CURSOR_HEIGH:Number = 10;
		static public var CALLBACK_INTERFACE:ISlider;
		static public var FONT_SIZE:Number = 10;
		static public var CONTROL_WIDTH:Number=150;
		static public var LINE_THICKNESS:Number=3;
		static public var SLIDER_CONTAINER:DisplayObjectContainer;
		static public var X_POS:Number=20;
		static public var Y_POS:Number=40;
		static public var Y_OFFSET:Number=0;
		static public var X_OFFSET:Number=0;
		static public var STICKY:Boolean=false;
		static public var _FontSize:Number;
		static public var TEXT_COLOR:int=0x666666;
		static public var LINE_COLOR:int=0x999999;
		static public var CURSOR_COLOR:int=0x555555;
		
		private var _Sticky:Boolean=false;
		private var _Length:Number;
		private var _Bar:Sprite
		private var _Cursor:Sprite
		private var _SliderContainer:DisplayObjectContainer;
		private var _XPos:Number
		private var _Title:String
		private var _YPos:Number
		private var _LineThickness:Number
		private var _Min:Number = 0;
		private var _Max:Number = 100;
		private var _Width:Number;
		private var _CursorWidth:Number;
		private var _CursorHeigh:Number;
		private var _ISlider:ISlider;
		private var _Mooving:Boolean=false;
		private var _ValueArea:TextField;
		private var _ValueFormat:TextFormat;
		private var _TitleArea:TextField;
		private var _TitleFormat:TextFormat;
		private var _Float:Number=0;
		private var _TextColor:int=TEXT_COLOR;
		private var _LineColor:int=LINE_COLOR;
		private var _CursorColor:int=CURSOR_COLOR;
		
		
		public function Slider(sliderContainer:DisplayObjectContainer = null,iSlider:ISlider=null)
		{
			
			_ISlider = iSlider;
			_SliderContainer = sliderContainer;
		}
		
		public function setPosition(xPos:Number,yPos:Number):void
		{
			_XPos=xPos;
			_YPos=yPos;
		}
		
		public function setWidth(Width:Number):void
		{
			_Width=Width;
		}
		
		public function setFont(size:Number):void
		{
			_FontSize=size;
					
		}
			
	
		
		public function setSticky(Sticky:Boolean):void
		{
			_Sticky=Sticky;
					
		}
		
		public function setCursorSize(Width:Number,Heigh:Number):void
		{
			_CursorWidth=Width;
			_CursorHeigh=Heigh;
			
		}
		
		public function create():void
		{
			if(!_CursorWidth) {_CursorWidth = CURSOR_WIDTH;}
			if(!_CursorHeigh) {_CursorHeigh= CURSOR_HEIGH;}
			if(!_ISlider) {_ISlider = CALLBACK_INTERFACE;}
			if(!_FontSize) {_FontSize = FONT_SIZE;}
			if(!_Width) {_Width = CONTROL_WIDTH;}
			if(!_LineThickness) {_LineThickness = LINE_THICKNESS;}			
			if(!_SliderContainer) {_SliderContainer = SLIDER_CONTAINER;}				
			if(!_XPos) {_XPos = X_POS;X_POS = _XPos + X_OFFSET;}			
			if(!_YPos) {_YPos = Y_POS ;Y_POS = _YPos + Y_OFFSET;}
			if(!_Sticky) {_Sticky = STICKY;}
			
			
			
			
			 createBar();
			 createCursor();
			 CreateTitle();
			 CreateValue();	
			 			
		}
		
		public function setTitle(Title:String):void
		{
			_Title= Title;
		}
		
		public function getTitle() : String
		{
			return(_Title);
		}
		
		public function setMinMax(Min:Number, Max:Number, Float:Number=0):void
		{
			 _Min = Min;
			 _Max = Max;
			 _Float = Float;
		}
		
		public function getCursorPosition():Number
		{
			 return ComputeRatio(_Cursor.x);
		}
		
		private function CreateValue():void
		{	
			_ValueFormat = new TextFormat();
			_ValueFormat.font = "Verdana";
            _ValueFormat.color = _TextColor;
            _ValueFormat.size = _FontSize;
         	
			_ValueArea = new TextField();
			_ValueArea.x = _TitleArea.x + _TitleArea.width + 5;
        	_ValueArea.y = _TitleArea.y ;
        	_TitleArea.autoSize = "left";
        	_ValueArea.height = _FontSize+8;
        	_ValueArea.selectable=false;
			_ValueArea.defaultTextFormat=_ValueFormat;
			
			_ValueArea.text=ComputeRatio(_Cursor.x).toString();
			
			_SliderContainer.addChild(_ValueArea);
		}
		
		public function hide():void
		{
			_ValueArea.visible= false;
			_TitleArea.visible= false;
			_Cursor.visible= false;
			_Bar.visible= false;
			_Cursor.visible= false;
		}
		
		public function show():void
		{
			_ValueArea.visible= true;
			_TitleArea.visible= true;
			_Cursor.visible= true;
			_Bar.visible= true;
			_Cursor.visible= true;
		}
		private function CreateTitle():void
		{	
			_TitleFormat = new TextFormat();
			_TitleFormat.font = "Verdana";
            _TitleFormat.color = _TextColor;
            _TitleFormat.size = _FontSize;
         	
			_TitleArea = new TextField();
			_TitleArea.x = _XPos;
        	_TitleArea.y = _YPos - _CursorHeigh - _FontSize*3/2;
        	_TitleArea.autoSize = "left"
        	_TitleArea.height = _FontSize+8;
        	_TitleArea.selectable=false;
			_TitleArea.defaultTextFormat=_TitleFormat;
					
			_TitleArea.text=_Title+" :";
			
			_SliderContainer.addChild(_TitleArea);
		}
		
		private function createCursor():void
		{			
			
			_Cursor = new Sprite();
			_Cursor.graphics.beginFill(_CursorColor);
			_Cursor.graphics.moveTo(_XPos +_Width/2 - _CursorWidth/2, _YPos - _CursorHeigh/2);
			_Cursor.graphics.lineTo(_XPos +_Width/2 - _CursorWidth/2, _YPos + _CursorHeigh/2);
			_Cursor.graphics.lineTo(_XPos +_Width/2 + _CursorWidth/2, _YPos + _CursorHeigh/2);
			_Cursor.graphics.lineTo(_XPos +_Width/2 + _CursorWidth/2, _YPos - _CursorHeigh/2);
			_Cursor.graphics.moveTo(_XPos +_Width/2 - _CursorWidth/2, _YPos - _CursorHeigh/2);
			
			_Cursor.addEventListener(MouseEvent.MOUSE_DOWN,onCursorMouseDown);
			
			_SliderContainer.addChild(_Cursor);
			
		}
		
		private function createBar():void
		{
			_Bar= new Sprite();
			_Bar.graphics.beginFill(_LineColor);
			_Bar.graphics.moveTo(_XPos, _YPos);
			_Bar.graphics.lineTo(_XPos, _YPos+_LineThickness/2);
			_Bar.graphics.lineTo(_XPos+_Width,_YPos+ _LineThickness/2);
			_Bar.graphics.lineTo(_XPos+_Width,_YPos);
			_Bar.graphics.lineTo(_XPos, _YPos);
						
			_SliderContainer.addChild(_Bar);
					
		}
		
		//onStageMouseMove
		
		private function onCursorMouseDown(event:MouseEvent):void
		{
			_Cursor.startDrag(false,(new Rectangle(-_Bar.width/2, 0, _Bar.width, 0)));
			_SliderContainer.addEventListener(MouseEvent.MOUSE_MOVE, onSliderContainerMouseMove);
			_SliderContainer.addEventListener(MouseEvent.MOUSE_UP, onSliderContainerMouseUp);
			event.stopPropagation();
		}
		
		public function onSliderContainerMouseUp(event:MouseEvent):void
		{
			_SliderContainer.removeEventListener(MouseEvent.MOUSE_MOVE, onSliderContainerMouseMove);
			_SliderContainer.removeEventListener(MouseEvent.MOUSE_UP, onSliderContainerMouseUp);
			_ValueArea.text = ComputeRatio(_Cursor.x).toString();
			_ISlider.onSliderRelease(this);
			_Cursor.stopDrag();
		}
		
		private function onSliderContainerMouseMove(event:MouseEvent):void
		{
			
			_ISlider.onSliderMove(this);
			if(_Sticky && !_Float)
			{
				
				var CurrentPosition:Number = ComputeRatio(event.stageX-_XPos -_Width/2 );
				setCursorPosition(Math.round(CurrentPosition));
			}
			_ValueArea.text = ComputeRatio(_Cursor.x).toString();
			event.updateAfterEvent();
		}
		
		public function setCursorPosition(CursorPosition:Number):void
		{
			if(CursorPosition>=_Max) {CursorPosition=_Max;}
			if(CursorPosition<=_Min) {CursorPosition=_Min;}
			
			_Cursor.x = (CursorPosition-_Min)*_Width / (_Max -_Min) - _Bar.width/2;
			_ValueArea.text = CursorPosition.toString();
		}
		
		private function ComputeRatio(pos:Number):Number	
		{
			var ratio:Number = (_Bar.width/2 + pos ) * (_Max-_Min)/_Bar.width + _Min;
			
			ratio = Math.round(ratio * Math.pow(10,_Float)) / Math.pow(10, _Float);
			
					
			return ratio;
		}
	}
}