package
{
	import flash.display.Sprite;
	import flash.events.*;
	import flash.geom.Vector3D;
	import SGComponents.Slider;
	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.render.Renderer;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;
	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="340", height="280")]
	public class anim1 extends Sprite 
	{

		public function anim1()
		{
			initEngine();
			initMaterials();
			initObjects();
			initListeners();
		}

		private var _Camera:Camera3D;

		private var _Cube:Cube;

		private var _CubeMaterial:WireColorMaterial;
		private var _Scene:Scene3D;
		private var _Sphere:Sphere;
		private var _SphereMaterial:WireColorMaterial;
		private var _Torus:Torus;
		private var _TorusMaterial:WireColorMaterial;
		private var _View:View3D;

		private function initEngine():void
		{
			_Scene = new Scene3D();			
			
			_Camera = new Camera3D();		
			_Camera.zoom = 5;
			_Camera.focus = 2000;
			_Camera.z = -10000;
			_Camera.y = 5000;
			_Camera.lookAt( new Vector3D(0, 0, 0) );
			
			_View = new View3D({x: stage.stageWidth*.5, y : stage.stageHeight*.5});
			_View.scene = _Scene;
			_View.camera = _Camera; 
			addChild(_View);			
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);		
		}

		private function initMaterials():void
		{
			_CubeMaterial = new WireColorMaterial(0xdd0000);
			_SphereMaterial = new WireColorMaterial(0x00dd00);
			_TorusMaterial = new WireColorMaterial(0x0000dd);			
		}

		private function initObjects():void
		{		
			_Cube = new Cube();
			_Cube.width = 80;
			_Cube.height = 80;
			_Cube.depth = 80;
			_Cube.x=50;
			_Cube.y = 50;
			_Cube.z= 100;
			_Cube.material = _CubeMaterial;
			_View.scene.addChild(_Cube);
			
			_Sphere = new Sphere();
			_Sphere.x=-130;
			_Sphere.z = -50;
			_Sphere.radius = 60;
			_Sphere.material = _SphereMaterial;
			_View.scene.addChild(_Sphere);
			
			_Torus = new Torus();
			_Torus.radius = 40;
			_Torus.z = -200;
			_Torus.x=130;
			_Torus.segmentsR = 10;
			_Torus.segmentsT = 10;
			_Torus.material = _TorusMaterial;
			_View.scene.addChild(_Torus);
		}

		private function onEnterFrame(event:Event):void
		{
			_Torus.rotationY+=3;
			_Sphere.rotationY-=2; 	
			_Cube.rotationY+=1; 	
				
			_View.render();
		}
	}
}