package
{
	import SGComponents.ISlider;
	import SGComponents.Slider;

	import away3d.cameras.*;
	import away3d.containers.*;
	import away3d.core.base.*;
	import away3d.core.math.*;
	import away3d.core.utils.*;
	import away3d.events.*;
	import away3d.loaders.*;
	import away3d.materials.*;
	import away3d.primitives.*;

	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	

	[SWF(backgroundColor="#ffffff", frameRate="30", quality="LOW", width="570", height="270")]
	public class anim2 extends Sprite implements ISlider
	{

		//engine variables
		private var _Scene:Scene3D;
		private var _Camera:HoverCamera3D;
		private var _View:View3D;

		//objects
		private var _Cube:Cube;

		// Sliders		
		private var _Slider1:Slider;
		private var _Slider2:Slider;
		private var _Slider3:Slider;
		private var _Slider4:Slider;
		private var _Slider5:Slider;
		private var _Slider6:Slider;

		public function anim2()
		{
			initEngine();
			initObjects();
			initSliders();
			initListeners();
		}

		private function initEngine():void
		{
			_Scene=new Scene3D();

			_Camera=new HoverCamera3D({zoom: 18, focus: 2000, distance: 18000});

			_View=new View3D({_Camera: _Camera,  x: stage.stageWidth * .6, y: stage.stageHeight * .5});
			_View.scene=_Scene;

			addChild(_View);

			_Camera.lookAt(new Vector3D(0, 0, 0));

		}

		private function initSliders():void
		{
			Slider.CALLBACK_INTERFACE=this;
			Slider.SLIDER_CONTAINER=stage;
			Slider.CURSOR_HEIGH=10;
			Slider.CURSOR_WIDTH=8;
			Slider.CONTROL_WIDTH=80;
			Slider.LINE_THICKNESS=3;
			Slider.FONT_SIZE=12;
			Slider.X_POS=20;
			Slider.Y_POS=40;
			Slider.Y_OFFSET=40;
			Slider.STICKY=true;

			_Slider1=new Slider();
			_Slider1.setMinMax(20, 150);
			_Slider1.setTitle("width");
			_Slider1.create();
			_Slider1.setCursorPosition(80);

			_Slider2=new Slider();
			_Slider2.setMinMax(20, 150);
			_Slider2.setTitle("depth");
			_Slider2.create();
			_Slider2.setCursorPosition(80);

			_Slider3=new Slider();
			_Slider3.setMinMax(20, 150);
			_Slider3.setTitle("height");
			_Slider3.create();
			_Slider3.setCursorPosition(80);

			_Slider4=new Slider();
			_Slider4.setMinMax(1, 5);
			_Slider4.setTitle("segmentsW");
			_Slider4.create();
			_Slider4.setCursorPosition(1);

			_Slider5=new Slider();
			_Slider5.setMinMax(1, 5);
			_Slider5.setTitle("segmentsH");
			_Slider5.create();
			_Slider5.setCursorPosition(1);

			_Slider6=new Slider();
			_Slider6.setMinMax(1, 5);
			_Slider6.setTitle("segmentsD");
			_Slider6.create();
			_Slider6.setCursorPosition(1);
		}

		public function updateMeshProperties(ThisSlider:Slider):void
		{
			switch (ThisSlider)
			{
				case _Slider1:
					_Cube.width=ThisSlider.getCursorPosition();
					break;
				case _Slider2:
					_Cube.depth=ThisSlider.getCursorPosition();
					break;
				case _Slider3:
					_Cube.height=ThisSlider.getCursorPosition();
					break;
				case _Slider4:
					_Cube.segmentsW=ThisSlider.getCursorPosition();
					break;
				case _Slider5:
					_Cube.segmentsH=ThisSlider.getCursorPosition();
					break;
				case _Slider6:
					_Cube.segmentsD=ThisSlider.getCursorPosition();
					break;
			}
		}

		private function initObjects():void
		{
			_Cube=new Cube();
			_Cube.width=80;
			_Cube.height=80;
			_Cube.depth=80;
			_Cube.segmentsH=1;
			_Cube.segmentsW=1;
			_Cube.segmentsD=1;
			_Cube.rotationX = 40;
			_Cube.scale(2);
			_Cube.x=-5;
			_Cube.y=10;
			_Cube.material=new WireColorMaterial(0xF4661B);
			_View.scene.addChild(_Cube);
		}

		private function initListeners():void
		{
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		private function onEnterFrame(event:Event):void
		{
			_Cube.rotationY+=1;
			_View.render();
		}

		public function onSliderMove(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

		public function onSliderRelease(ThisSlider:Slider):void
		{
			updateMeshProperties(ThisSlider);
		}

	}
}